# Kamaji2 Aurelia Components

## Install
```
$ npm install ka-components
```
## Usage
Add the following line to */src/main.js*
```
aurelia.use.plugin(PLATFORM.moduleName('ka-components'));
```
Add the following to your main app Sass file (eg: */src/static/app.sass*):
```
$text-color: #404040;
$primary-color: #ed5a23;
$secondary-color: #11254b;
$accent-color: #ff6600;
$error-color: #ff4400;
$success-color: #1CC800;

@import '../../node_modules/ka-components/src/style/ka'
```


### ka-table
```
<ka-table
  endpoint=""
  client=""
  limit=""       // integer - Number of records to fetch, default is 10
  columns=""     // string|array - Kamaji's field names to use as table columns, defaults to all fields
  filtrables=""  // string|array - Kamaji's field names to make available as filters, defaults to all fields
  editables=""   // string|array - Kamaji's field names to set as editable, defaults to none
  exportables="" // string|array - Kamaji's field names to set as exportable, defaults to all fields
  prefilter=""   // string - Predefined hardcoded filter string to be used for fetching data
  routes=""      // object - Routes names for actions, if dialog is true, then open in dialog, default is { add: null, edit: null, dialog: false, data: {} }
  actions=""     // string|array - Action buttons to show, defaults to ["filter","export","add","edit"]
  params=""      // object - Additional parameters, defaults to {}
  query=""       // string - Additional query string to be used for fetching data
  >
  <template replace-part="tools-left"></template>
  <template replace-part="tools-right"></template>
  <template replace-part="thead-tr"></template>
  <template replace-part="tbody-tr"></template>
</ka-table>
```
**`endpoint`**
- Type: string
- Default: null
- Description: Kamaji's data endpoint, if not set, component will try to get containing model's 'this.endpoint' value

**`client`**
- Type: object
- Default: null
- Description: Aurelia's http client to be used for fetching data, default is containing model's 'this.api' reference

### ka-control

```
<ka-control
  name=""
  schema=""
  value=""
  label=""
  required=""
  readonly=""
  description=""
  placeholder=""
  params=""
  change="">
</ka-control>
```
Schema structure:
```
{
  control: ''
  datasource: ''
}
```