define(['exports', 'aurelia-framework', 'moment', 'pikaday'], function (exports, _aureliaFramework, _moment, _pikaday) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.controlDateValueConverter = exports.KaControlDate = undefined;

  var _moment2 = _interopRequireDefault(_moment);

  var _pikaday2 = _interopRequireDefault(_pikaday);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };

  function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
      enumerable: descriptor.enumerable,
      configurable: descriptor.configurable,
      writable: descriptor.writable,
      value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
      desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
      desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
      return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
      desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
      desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
      Object['define' + 'Property'](target, property, desc);
      desc = null;
    }

    return desc;
  }

  function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
  }

  var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5;

  var KaControlDate = exports.KaControlDate = (_dec = (0, _aureliaFramework.customElement)('ka-control-date'), _dec2 = (0, _aureliaFramework.inject)(Element), _dec3 = (0, _aureliaFramework.bindable)(), _dec4 = (0, _aureliaFramework.bindable)({ defaultBindingMode: _aureliaFramework.bindingMode.twoWay }), _dec5 = (0, _aureliaFramework.bindable)(), _dec6 = (0, _aureliaFramework.bindable)(), _dec7 = (0, _aureliaFramework.bindable)(), _dec(_class = _dec2(_class = (_class2 = function () {
    function KaControlDate(element) {
      _classCallCheck(this, KaControlDate);

      _initDefineProp(this, 'schema', _descriptor, this);

      _initDefineProp(this, 'value', _descriptor2, this);

      _initDefineProp(this, 'readonly', _descriptor3, this);

      _initDefineProp(this, 'placeholder', _descriptor4, this);

      _initDefineProp(this, 'params', _descriptor5, this);

      this.element = element;
    }

    KaControlDate.prototype.attached = function attached() {
      this.picker = new _pikaday2.default({
        field: this.element.querySelector('input.display-value'),
        format: 'DD/MM/YYYY',
        firstDay: 1,
        i18n: {
          previousMonth: 'Mese precedente',
          nextMonth: 'Mese seguente',
          months: ['Gennaio', 'Febbraio', 'Marzo', 'Aprile', 'Maggio', 'Giugno', 'Luglio', 'Agosto', 'Settembre', 'Ottobre', 'Novembre', 'Dicembre'],
          weekdays: ['Domenica', 'Lunedì', 'Martedì', 'Mercoledì', 'Giovedì', 'Venerdì', 'Sabato'],
          weekdaysShort: ['Dom', 'Lun', 'Mar', 'Mer', 'Gio', 'Ven', 'Sab']
        }
      });
    };

    KaControlDate.prototype.schemaChanged = function schemaChanged(schema) {
      if (!schema) {
        konsole.warn('ka-control-date: missing schema!', schema);
        return;
      }
      if (typeof schema === 'string') {
        try {
          schema = JSON.parse(schema);
        } catch (error) {
          konsole.error('ka-control-date: invalid schema provided!', schema);
          return;
        }
      }

      var _arr = ['readonly'];

      for (var _i = 0; _i < _arr.length; _i++) {
        var attribute = _arr[_i];
        if (this[attribute] === null) {
          if (this.element.getAttribute(attribute)) {
            this[attribute] = String(this.element.getAttribute(attribute)).toLowerCase() === 'true';
          } else if (_typeof(schema[attribute]) !== undefined) {
            this[attribute] = String(schema[attribute]).toLowerCase() === 'true';
          }
        } else this[attribute] = String(this[attribute]).toLowerCase() === 'true';
      }

      konsole.debug('ka-control-date: schema changed!', schema);
      this._schema = schema;
    };

    KaControlDate.prototype.keydown = function keydown() {
      return !this.readonly;
    };

    return KaControlDate;
  }(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec3], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'value', [_dec4], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'readonly', [_dec5], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'placeholder', [_dec6], {
    enumerable: true,
    initializer: function initializer() {
      return '';
    }
  }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'params', [_dec7], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  })), _class2)) || _class) || _class);

  var controlDateValueConverter = exports.controlDateValueConverter = function () {
    function controlDateValueConverter() {
      _classCallCheck(this, controlDateValueConverter);
    }

    controlDateValueConverter.prototype.toView = function toView(value) {
      var format = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'DD/MM/YYYY';

      if (_moment2.default.utc(value).isValid()) {
        konsole.debug('ControlDateValueConverter - From ' + _moment2.default.utc(value) + ' to view ' + _moment2.default.utc(value).local().format(format));
        return _moment2.default.utc(value).local().format(format);
      }
      konsole.debug('ControlDateValueConverter - No conversion toView on ' + value);
      return value;
    };

    controlDateValueConverter.prototype.fromView = function fromView(value) {
      var format = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'DD/MM/YYYY';

      if ((0, _moment2.default)(value, format).isValid()) {
        konsole.debug('ControlDateValueConverter - From view ' + (0, _moment2.default)(value, format) + ' to ' + (0, _moment2.default)(value, format).utc().format());
        return (0, _moment2.default)(value, format).hour((0, _moment2.default)().hour()).minute((0, _moment2.default)().minute()).utc().format();
      }
      konsole.debug('ControlDateValueConverter - No conversion fromView on ' + value);
      return value;
    };

    return controlDateValueConverter;
  }();
});