define(['exports', 'aurelia-framework', 'aurelia-router', '../ka-api/ka-api', 'environment'], function (exports, _aureliaFramework, _aureliaRouter, _kaApi, _environment) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.KaNavbar = undefined;

  var _environment2 = _interopRequireDefault(_environment);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
      enumerable: descriptor.enumerable,
      configurable: descriptor.configurable,
      writable: descriptor.writable,
      value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
      desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
      desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
      return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
      desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
      desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
      Object['define' + 'Property'](target, property, desc);
      desc = null;
    }

    return desc;
  }

  function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
  }

  var _dec, _dec2, _dec3, _class, _desc, _value, _class2, _descriptor;

  var KaNavbar = exports.KaNavbar = (_dec = (0, _aureliaFramework.customElement)('ka-navbar'), _dec2 = (0, _aureliaFramework.inject)(Element, _aureliaRouter.Router, _kaApi.KaApi), _dec3 = (0, _aureliaFramework.observable)(), _dec(_class = _dec2(_class = (_class2 = function () {
    function KaNavbar(element, router, api) {
      var _this = this;

      _classCallCheck(this, KaNavbar);

      _initDefineProp(this, 'visible', _descriptor, this);

      this.appName = _environment2.default.appName;

      this.element = element;
      this.router = router;
      this.api = api;
      document.addEventListener('click', function (e) {
        if (!_this.visible) return;
        var target = e.target;
        while (target) {
          if (target === _this.nav) return;
          if (target === _this.button) return;
          target = target.parentNode;
        }
        _this.hide();
      });
    }

    KaNavbar.prototype.attached = function attached() {
      var _this2 = this;

      this.routes = [];

      var _loop = function _loop() {
        if (_isArray) {
          if (_i >= _iterator.length) return 'break';
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) return 'break';
          _ref = _i.value;
        }

        var route = _ref;

        if (!_this2.api.user && !route.settings.authGroups) _this2.routes.push(route);else if (_this2.api.user && !route.settings.authGroups) _this2.routes.push(route);else if (_this2.api.user && route.settings.authGroups && _this2.api.user.groups && _this2.api.user.groups.some(function (e) {
          return route.settings.authGroups.includes(e);
        })) _this2.routes.push(route);
      };

      for (var _iterator = this.router.navigation, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref;

        var _ret = _loop();

        if (_ret === 'break') break;
      }
    };

    KaNavbar.prototype.hide = function hide() {
      this.visible = false;
    };

    KaNavbar.prototype.show = function show() {
      this.visible = true;
    };

    KaNavbar.prototype.toggle = function toggle() {
      this.visible = !this.visible;
    };

    return KaNavbar;
  }(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'visible', [_dec3], {
    enumerable: true,
    initializer: function initializer() {
      return false;
    }
  })), _class2)) || _class) || _class);
});