define(['exports', 'aurelia-framework', 'aurelia-router'], function (exports, _aureliaFramework, _aureliaRouter) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.KaTabs = undefined;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var _dec, _dec2, _class;

  var KaTabs = exports.KaTabs = (_dec = (0, _aureliaFramework.customElement)('ka-tabs'), _dec2 = (0, _aureliaFramework.inject)(Element, _aureliaRouter.Router), _dec(_class = _dec2(_class = function () {
    function KaTabs(element, router) {
      _classCallCheck(this, KaTabs);

      this.tabs = [];

      this.element = element;
      this.name = 'ka-tab-' + this.element.id;
      this.router = router;
    }

    KaTabs.prototype.bind = function bind(bindingContext, overrideContext) {
      this.parent = bindingContext;
    };

    KaTabs.prototype.attached = function attached() {
      var _this = this;

      this.init().then(function (tabs) {
        var tab = tabs[0];
        var queryParams = _this.router.currentInstruction.queryParams;
        if (queryParams[_this.name]) tab = _this.tabs.find(function (item) {
          return item.name === queryParams[_this.name];
        }) || tab;
        _this.select(tab);
      });
      this.element.style.display = 'block';
      this.contents.style.display = 'block';
      this.contents.style.position = 'relative';
      this.contents.style.width = '100%';
      this.contents.style.whiteSpace = 'nowrap';
      this.contents.style.overflow = 'hidden';
    };

    KaTabs.prototype.init = function init() {
      var _this2 = this;

      this.tabs = [];
      return new Promise(function (resolve, reject) {
        var elements = Array.from(_this2.contents.children).filter(function (x) {
          return x.matches('ka-tab');
        });
        for (var _iterator = elements, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
          var _ref;

          if (_isArray) {
            if (_i >= _iterator.length) break;
            _ref = _iterator[_i++];
          } else {
            _i = _iterator.next();
            if (_i.done) break;
            _ref = _i.value;
          }

          var element = _ref;

          element.style.opacity = '0';
          element.style.width = '100%';
          element.style.position = 'absolute';
          element.style.top = '0';
          element.style.left = '0';
          element.style.transition = 'left 0.3s ease-in-out';
          _this2.tabs.push({
            element: element,
            label: element.getAttribute('label') || element.id || 'tab-' + elements.indexOf(element),
            name: element.id,
            readonly: true,
            visible: false
          });
        }
        resolve(_this2.tabs);
      });
    };

    KaTabs.prototype.isDialog = function isDialog() {
      return this.parent && this.parent.params && this.parent.params.dialog;
    };

    KaTabs.prototype.select = function select(tab) {
      var currentTab = this.current;
      var current = this.tabs.indexOf(currentTab);
      var index = this.tabs.indexOf(tab);

      if (tab.element.id && !this.isDialog()) {
        var queryParams = Object.assign({}, this.router.currentInstruction.params, this.router.currentInstruction.queryParams);
        var route = this.router.currentInstruction.config;
        queryParams[this.name] = tab.name;
        this.router.navigateToRoute(route.name, queryParams, { trigger: false, replace: false });
      }

      for (var i in this.tabs) {
        i = parseInt(i, 10);
        var element = this.tabs[i].element;
        if (i === index) {
          element.style.position = 'relative';
          element.style.left = '0';
          this.tabs[i].visible = true;
        } else if (i < index) {
          element.style.position = 'absolute';
          element.style.left = '-100%';
          this.tabs[i].visible = false;
        } else if (i > index) {
          element.style.position = 'absolute';
          element.style.left = '100%';
          this.tabs[i].visible = false;
        }
        if (i === current || i === index) element.style.opacity = '1';else element.style.opacity = '0';
      }
    };

    _createClass(KaTabs, [{
      key: 'current',
      get: function get() {
        return this.tabs.find(function (item) {
          return item.visible;
        });
      }
    }]);

    return KaTabs;
  }()) || _class) || _class);
});