define(['exports', 'aurelia-framework'], function (exports, _aureliaFramework) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.KaTooltipCustomAttribute = undefined;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _dec, _dec2, _class;

  var KaTooltipCustomAttribute = exports.KaTooltipCustomAttribute = (_dec = (0, _aureliaFramework.customAttribute)('ka-tooltip'), _dec2 = (0, _aureliaFramework.inject)(Element), _dec(_class = _dec2(_class = function () {
    function KaTooltipCustomAttribute(element) {
      _classCallCheck(this, KaTooltipCustomAttribute);

      this.element = element;
    }

    KaTooltipCustomAttribute.prototype.attached = function attached() {
      var _this = this;

      this.element.addEventListener('mouseover', function (e) {
        if (_this.tooltip) return;
        var bounds = e.target.getBoundingClientRect();
        _this.tooltip = document.createElement('div');
        _this.tooltip.classList.add('ka-tooltip');
        _this.tooltip.style.top = bounds.top + bounds.height + 'px';
        _this.tooltip.style.left = bounds.left + bounds.width / 2 + 'px';
        _this.tooltip.innerHTML = _this.value;
        document.getElementsByTagName('body')[0].insertBefore(_this.tooltip, document.getElementsByTagName('body')[0].children[0]);
        setTimeout(function () {
          if (!_this.tooltip) return;_this.tooltip.classList.add('visible');
        }, 1000);
      });
      this.element.addEventListener('mouseout', function (e) {
        if (!_this.tooltip) return;
        document.getElementsByTagName('body')[0].removeChild(_this.tooltip);
        _this.tooltip = null;
      });
    };

    KaTooltipCustomAttribute.prototype.detached = function detached() {
      if (!this.tooltip) return;
      document.getElementsByTagName('body')[0].removeChild(this.tooltip);
      this.tooltip = null;
    };

    return KaTooltipCustomAttribute;
  }()) || _class) || _class);
});