'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _kaDialog = require('./ka-dialog/ka-dialog');

Object.keys(_kaDialog).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _kaDialog[key];
    }
  });
});

var _kaToast = require('./ka-toast/ka-toast');

Object.keys(_kaToast).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _kaToast[key];
    }
  });
});

var _kaApi = require('./ka-api/ka-api');

Object.keys(_kaApi).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _kaApi[key];
    }
  });
});
exports.configure = configure;

var _aureliaFramework = require('aurelia-framework');

var _kaConsole = require('./ka-console/ka-console');

window.konsole = new _kaConsole.KaConsole();

function configure(config) {
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-button/ka-button')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-input/ka-input')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-input/ka-input-controls')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-navbar/ka-navbar')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-resource/ka-resource')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-table/ka-table')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-table/ka-tableFilters')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-tabs/ka-tabs')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-tooltip/ka-tooltip')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-enter/ka-enter')]);

  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-progress/ka-progress')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-layout/ka-layout')]);

  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control/ka-control')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control-check/ka-control-check')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control-combo/ka-control-combo')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control-date/ka-control-date')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control-editor/ka-control-editor')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control-file/ka-control-file')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control-list/ka-control-list')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control-number/ka-control-number')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control-password/ka-control-password')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control-table/ka-control-table')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control-text/ka-control-text')]);
  config.globalResources([_aureliaFramework.PLATFORM.moduleName('./ka-control-textarea/ka-control-textarea')]);
}