'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KaApi = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _aureliaFramework = require('aurelia-framework');

var _aureliaHttpClient = require('aurelia-http-client');

var _aureliaRouter = require('aurelia-router');

var _environment = require('environment');

var _environment2 = _interopRequireDefault(_environment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var KaApi = exports.KaApi = (_dec = (0, _aureliaFramework.inject)(_aureliaRouter.Router), _dec(_class = function () {
  function KaApi(router) {
    var _this = this;

    _classCallCheck(this, KaApi);

    this.routeLogin = 'login';
    this.routeHome = 'home';
    this.storage = _environment2.default.storage && window[_environment2.default.storage] ? window[_environment2.default.storage] : localStorage;
    this._accessToken = '';
    this._refreshToken = '';
    this._refreshPromise = null;
    this._user = null;
    this._baseUrl = this.storage.getItem('api_base_url') || (_environment2.default.api && _environment2.default.api.kamaji ? _environment2.default.api.kamaji : _environment2.default.api);
    this._isKamaji1 = _environment2.default.api && typeof _environment2.default.api === 'string' && !!_environment2.default.api.match(/api\.kamaji\.it\/v1\//g);

    this._accessToken = this.storage.getItem('access_token') || '';
    this._refreshToken = this.storage.getItem('refresh_token') || '';
    this._user = this.storage.getItem('user') ? JSON.parse(this.storage.getItem('user')) : null;
    this._refreshUrl = '';
    this.client = new _aureliaHttpClient.HttpClient();
    this.client._baseUrl = this._baseUrl;
    this.router = router;

    this.client.configure(function (x) {
      x.withBaseUrl(_this.baseUrl);
      x.withInterceptor({
        request: function request(msg) {
          if (_this.accessToken.length && (!_this._refreshUrl.length || msg.url !== _this._refreshUrl)) {
            msg.headers.add('Authorization', 'Bearer ' + _this.accessToken);
          }
          return msg;
        },
        response: function response(msg) {
          if (String(msg.statusCode) !== '204' && msg.responseType === 'json' && typeof msg.response === 'string') {
            msg.response = JSON.parse(msg.response);
          }
          return msg;
        },
        responseError: function responseError(msg) {
          if (msg.statusCode === 401 && _this.refreshToken.length && msg.requestMessage.url !== _this._refreshUrl) {
            return _this.refresh(_this.refreshToken).then(function (success) {
              return _this.client.send(msg.requestMessage);
            }, function (error) {
              return error;
            });
          }
          return Promise.reject(msg);
        }
      });
    });
  }

  KaApi.prototype.login = function login(username, password) {
    var _this2 = this;

    return this.client.post('auth', { username: username, password: password, grant_type: 'password' }).then(function (msg) {
      _this2.accessToken = msg.response.access_token;
      _this2.refreshToken = msg.response.refresh_token;
      if (_this2._isKamaji1) {
        return _this2.client.get('auth').then(function (x) {
          var response = x.response;
          return _this2.client.get(response.endpoint + '/' + response.userid, { depth: 0 }).then(function (x) {
            _this2.user = x.response;
            konsole.debug(_this2.user);
            _this2.router.navigateToRoute(_this2.routeHome);
            return Promise.resolve(x);
          }, function (x) {
            _this2.user = null;
            return Promise.reject(x);
          });
        }, function (x) {
          _this2.user = null;
          return Promise.reject(x);
        });
      }
      return _this2.client.get('me?depth=0').then(function (x) {
        _this2.user = x.response;
        konsole.debug('me', _this2.user);
        _this2.router.navigateToRoute(_this2.routeHome);
        return Promise.resolve(x);
      }, function (x) {
        _this2.user = null;
        return Promise.reject(x);
      });
    }, function (x) {
      _this2.accessToken = '';
      _this2.refreshToken = '';
      _this2.user = null;
      return Promise.reject(x);
    });
  };

  KaApi.prototype.logout = function logout() {
    this.accessToken = '';
    this.refreshToken = '';
    this.user = null;
    localStorage.clear();
    sessionStorage.clear();
    this.router.navigateToRoute(this.routeLogin);
  };

  KaApi.prototype.refresh = function refresh(token) {
    var _this3 = this;

    if (this._refreshPromise) return this._refreshPromise;
    this._refreshUrl = 'auth/refresh/' + token;
    this._refreshPromise = this.client.post(this._refreshUrl).then(function (msg) {
      _this3.accessToken = msg.response.access_token;
      _this3.refreshToken = msg.response.refresh_token;
      return Promise.resolve(msg.response);
    }, function (x) {
      _this3.logout();
      return Promise.reject(x);
    });
    this._refreshPromise.finally(function () {
      _this3._refreshUrl = '';
      _this3._refreshPromise = null;
    });
    return this._refreshPromise;
  };

  KaApi.prototype.get = function get(endpoint, params) {
    var queryString = (typeof params === 'undefined' ? 'undefined' : _typeof(params)) === 'object' ? '?' + this.buildQueryString(params) : '';
    return this.client.get(this.baseUrl + endpoint + queryString);
  };

  KaApi.prototype.post = function post(endpoint, data) {
    return this.client.post(this.baseUrl + endpoint, data);
  };

  KaApi.prototype.put = function put(endpoint, data) {
    return this.client.put(this.baseUrl + endpoint, data);
  };

  KaApi.prototype.patch = function patch(endpoint, data) {
    return this.client.patch(this.baseUrl + endpoint, data);
  };

  KaApi.prototype.delete = function _delete(endpoint) {
    return this.client.delete(this.baseUrl + endpoint);
  };

  KaApi.prototype.buildQueryString = function buildQueryString(params) {
    var query = [];
    for (var _iterator = Object.entries(params), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var _ref2 = _ref,
          key = _ref2[0],
          value = _ref2[1];
      query.push(key + '=' + encodeURIComponent(value));
    }return query.join('&');
  };

  _createClass(KaApi, [{
    key: 'baseUrl',
    get: function get() {
      return this._baseUrl;
    },
    set: function set(value) {
      this._baseUrl = value;
      this.storage.setItem('api_base_url', value);
      if (this.client) {
        this.client._baseUrl = this._baseUrl;
        this.client.configure(function (conf) {
          conf.withBaseUrl(value);
        });
      }
    }
  }, {
    key: 'accessToken',
    get: function get() {
      return this._accessToken;
    },
    set: function set(value) {
      this._accessToken = value || '';
      if (value) this.storage.setItem('access_token', value);else this.storage.removeItem('access_token');
    }
  }, {
    key: 'refreshToken',
    get: function get() {
      return this._refreshToken;
    },
    set: function set(value) {
      this._refreshToken = value || '';
      if (value) this.storage.setItem('refresh_token', value);else this.storage.removeItem('refresh_token');
    }
  }, {
    key: 'user',
    get: function get() {
      return this._user;
    },
    set: function set(value) {
      this._user = value || '';
      if (value) this.storage.setItem('user', JSON.stringify(value));else this.storage.removeItem('user');
    }
  }, {
    key: 'isAuthenticated',
    get: function get() {
      return !!this.accessToken.length && !!this.user;
    }
  }]);

  return KaApi;
}()) || _class);