'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KaControl = undefined;

var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11;

var _aureliaFramework = require('aurelia-framework');

var _aureliaValidation = require('aurelia-validation');

var _aureliaRouter = require('aurelia-router');

var _kaComponents = require('ka-components');

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var KaControl = exports.KaControl = (_dec = (0, _aureliaFramework.customElement)('ka-control'), _dec2 = (0, _aureliaFramework.inject)(Element, _aureliaRouter.Router, _kaComponents.KaApi, _aureliaFramework.BindingEngine, _aureliaFramework.NewInstance.of(_aureliaValidation.ValidationController)), _dec3 = (0, _aureliaFramework.bindable)(), _dec4 = (0, _aureliaFramework.bindable)({ defaultBindingMode: _aureliaFramework.bindingMode.twoWay }), _dec5 = (0, _aureliaFramework.bindable)(), _dec6 = (0, _aureliaFramework.bindable)(), _dec7 = (0, _aureliaFramework.bindable)(), _dec8 = (0, _aureliaFramework.bindable)(), _dec9 = (0, _aureliaFramework.bindable)(), _dec10 = (0, _aureliaFramework.bindable)(), _dec11 = (0, _aureliaFramework.bindable)(), _dec12 = (0, _aureliaFramework.bindable)(), _dec13 = (0, _aureliaFramework.bindable)(), _dec(_class = _dec2(_class = (_class2 = function () {
  function KaControl(element, router, api, binding, validator) {
    _classCallCheck(this, KaControl);

    _initDefineProp(this, 'schema', _descriptor, this);

    _initDefineProp(this, 'value', _descriptor2, this);

    _initDefineProp(this, 'name', _descriptor3, this);

    _initDefineProp(this, 'readonly', _descriptor4, this);

    _initDefineProp(this, 'required', _descriptor5, this);

    _initDefineProp(this, 'label', _descriptor6, this);

    _initDefineProp(this, 'description', _descriptor7, this);

    _initDefineProp(this, 'placeholder', _descriptor8, this);

    _initDefineProp(this, 'error', _descriptor9, this);

    _initDefineProp(this, 'params', _descriptor10, this);

    this.errors = null;
    this.buttons = [];

    _initDefineProp(this, 'change', _descriptor11, this);

    this.element = element;
    this.router = router;
    this.api = api;
    this.binding = binding;
    this.validator = validator;
    this.validator.validateTrigger = _aureliaValidation.validateTrigger.manual;

    _aureliaValidation.ValidationRules.ensure('value').required().when(function (self) {
      return self.required;
    }).withMessage('Campo obbligatorio').equals(true).when(function (self) {
      return self.schema.control === 'check' && self.required;
    }).withMessage('Spunta obbligatoria').satisfies(function (value, self) {
      return value >= self.schema.min && value <= self.schema.max;
    }).when(function (self) {
      return self.schema.control === 'number' && self.schema.min && self.schema.max;
    }).withMessage('Il valore deve essere compreso tra ${min} e ${max}').satisfies(function (value, self) {
      return value >= self.schema.min;
    }).when(function (self) {
      return self.schema.control === 'number' && self.schema.min && !self.schema.max;
    }).withMessage('Il valore deve essere uguale o maggiore di ${min}').satisfies(function (value, self) {
      return value <= self.schema.max;
    }).when(function (self) {
      return self.schema.control === 'number' && !self.schema.min && self.schema.max;
    }).withMessage('Il valore deve essere minore o uguale a ${max}').satisfies(function (value, self) {
      return value.length >= self.schema.min && value.length <= self.schema.max;
    }).when(function (self) {
      return self.value && ['text', 'textarea', 'password'].includes(self.schema.control) && self.schema.min && self.schema.max;
    }).withMessage('Il numero di caratteri deve essere compreso tra ${min} e ${max}').satisfies(function (value, self) {
      return value.length >= self.schema.min;
    }).when(function (self) {
      return self.value && ['text', 'textarea', 'password'].includes(self.schema.control) && self.schema.min && !self.schema.max;
    }).withMessage('Il valore deve essere di almeno ${min} caratteri').satisfies(function (value, self) {
      return value.length <= self.schema.max;
    }).when(function (self) {
      return self.value && ['text', 'textarea', 'password'].includes(self.schema.control) && !self.schema.min && self.schema.max;
    }).withMessage('Il valore non deve superare i ${max} caratteri').ensure('displayValue').required().when(function (self) {
      return self.required;
    }).withMessage('Campo obbligatorio').satisfies(function (value, self) {
      return value === null || value === '' || /^\d{2}\/\d{2}\/\d{4}$/g.test(value) && moment(value, 'DD-MM-YYYY').isValid();
    }).when(function (self) {
      return self.schema.control === 'date' || self.schema.control === 'age';
    }).withMessage('Formato data non valido').on(this);
  }

  KaControl.prototype.bind = function bind(bindingContext) {
    this.parentContext = bindingContext;

    if (this.name && this.parentContext.resource) this.bindResource();

    if (!this.name && this.schema) this.schemaChanged(this.schema);
  };

  KaControl.prototype.attached = function attached() {
    if (this.element.hasAttribute('buttons')) {
      this.buttons = this.element.getAttribute('buttons').split(',');
    }
  };

  KaControl.prototype.detached = function detached() {
    this.unbindResource();
  };

  KaControl.prototype.schemaChanged = function schemaChanged(schema) {
    if (!schema) return;
    this.readonly = this.readonly !== null ? String(this.readonly) === 'true' : String(schema.readonly) === 'true';
    if (!this.readonly && this._bindResource && this.parentContext.resource.readonly !== null) this.readonly = String(this.parentContext.resource.readonly) === 'true';
    this.required = this.required !== null ? String(this.required) === 'true' : String(schema.required) === 'true';
    this.label = this.label || schema.label || null;
    this.placeholder = this.placeholder || schema.placeholder || '';
    this.description = this.description || schema.description || null;
    this.viewStrategy = new _aureliaFramework.InlineViewStrategy('<template><ka-control-' + schema.control + ' schema.bind="schema" value.bind="value & validate" readonly.bind="readonly" placeholder.bind="placeholder" ' + (schema.control === 'check' ? 'description.bind="description"' : '') + ' params.bind="params"></ka-control-' + schema.control + '></template>');
  };

  KaControl.prototype.valueChanged = function valueChanged(value) {
    if (this._bindResource && this.parentContext.resource.data) this.parentContext.resource.data[this.name] = value;
    this.validate();
    if (typeof this.change === 'function') {
      this.change(value);
    }
  };

  KaControl.prototype.readonlyChanged = function readonlyChanged() {
    if (!this.schema) return;
    if (String(this.schema.readonly) === 'true') this.readonly = true;
  };

  KaControl.prototype.validate = function validate() {
    var _this = this;

    var validator = this.validator.validate();
    validator.then(function (result) {
      if (result.valid) {
        _this.element.classList.remove('error');
      } else {
        _this.element.classList.add('error');
      }
    });
    return validator;
  };

  KaControl.prototype.setError = function setError(message) {
    if (message && typeof message === 'string') {
      this.element.classList.add('error');
      this.validator.errors = [message];
    } else if (message) {
      this.element.classList.add('error');
      this.validator.errors = message;
    } else {
      this.element.classList.remove('error');
      this.validator.errors = [];
    }
  };

  KaControl.prototype.bindResource = function bindResource() {
    var _this2 = this;

    if (this.parentContext.resource) {
      this.parentContext.resource.controls[this.name] = this;
      if (this.parentContext.resource.schema) {
        this.resourceSchemaBinding = this.binding.expressionObserver(this, 'parentContext.resource.schema.' + this.name).subscribe(function (value) {
          return _this2.schema = value;
        });
      } else if (this.schema) {
        this.schemaChanged(this.schema);
      }
      if (this.parentContext.resource.data) {
        this.resourceValueBinding = this.binding.expressionObserver(this, 'parentContext.resource.data.' + this.name).subscribe(function (value) {
          if (value !== _this2.value) _this2.value = value;
        });
      }
    }
    if (!this.readonly) this.resourceReadonlyBinding = this.binding.expressionObserver(this, 'parentContext.resource.readonly').subscribe(function (value) {
      _this2.readonly = value;
    });
    this._bindResource = true;
  };

  KaControl.prototype.unbindResource = function unbindResource() {
    if (this.resourceSchemaBinding) this.resourceSchemaBinding.dispose();
    if (this.resourceValueBinding) this.resourceValueBinding.dispose();
    if (this.resourceReadonlyBinding) this.resourceReadonlyBinding.dispose();
    this._bindResource = false;
  };

  KaControl.prototype.clear = function clear() {
    this.value = null;
  };

  return KaControl;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec3], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'value', [_dec4], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'name', [_dec5], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'readonly', [_dec6], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'required', [_dec7], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, 'label', [_dec8], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, 'description', [_dec9], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, 'placeholder', [_dec10], {
  enumerable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, 'error', [_dec11], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, 'params', [_dec12], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, 'change', [_dec13], {
  enumerable: true,
  initializer: function initializer() {
    return function (value) {};
  }
})), _class2)) || _class) || _class);