'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KaLayout = undefined;

var _dec, _dec2, _class;

var _aureliaFramework = require('aurelia-framework');

var _aureliaRouter = require('aurelia-router');

var _kaComponents = require('ka-components');

var _navigation = require('navigation');

var _navigation2 = _interopRequireDefault(_navigation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var KaLayout = exports.KaLayout = (_dec = (0, _aureliaFramework.customElement)('ka-layout'), _dec2 = (0, _aureliaFramework.inject)(Element, _aureliaRouter.Router, _kaComponents.KaApi), _dec(_class = _dec2(_class = function () {
  function KaLayout(element, router, api) {
    var _this = this;

    _classCallCheck(this, KaLayout);

    this._collapsed = false;
    this._navigation = _navigation2.default;
    this._intervals = [];

    this.element = element;
    this.router = router;
    this.api = api;
    document.addEventListener('click', function (e) {
      if (e.target.closest('.no-toggle')) return;
      if (e.target.classList.contains('expand') || e.target.classList.contains('collapse')) return;
      var isBurger = e.target === _this.burgerAside || e.target === _this.burgerHeader || e.target.parentElement && (e.target.parentElement === _this.burgerAside || e.target.parentElement === _this.burgerHeader);
      if (!isBurger && !_this._collapsed && window.innerWidth < 860) _this.toggle();
    });
  }

  KaLayout.prototype.attached = function attached() {
    if (window.innerWidth < 860) this.toggle();
    this.activateBadges(this._navigation);
  };

  KaLayout.prototype.detached = function detached() {
    for (var _iterator = this._intervals, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var interval = _ref;
      clearInterval(interval);
    }
  };

  KaLayout.prototype.toggle = function toggle() {
    this._collapsed = !this._collapsed;
    if (this._collapsed) this.element.classList.add('collapsed');else this.element.classList.remove('collapsed');
  };

  KaLayout.prototype.activateBadges = function activateBadges(items) {
    var _this2 = this;

    var _loop = function _loop() {
      if (_isArray2) {
        if (_i2 >= _iterator2.length) return 'break';
        _ref2 = _iterator2[_i2++];
      } else {
        _i2 = _iterator2.next();
        if (_i2.done) return 'break';
        _ref2 = _i2.value;
      }

      var item = _ref2;

      if (item.nav && item.nav.length > 0 && _this2.authorized(item)) _this2.activateBadges(item.nav);
      if (!item.badge || !item.badge.promise || !_this2.authorized(item)) return 'continue';
      var callback = function callback() {
        new Promise(function (resolve, reject) {
          return item.badge.promise(resolve, reject, _this2.api);
        }).then(function (x) {
          item.badge.value = x;
        }).catch(function () {
          item.badge.value = null;
        });
      };
      _this2._intervals.push(setInterval(callback, item.badge.interval || 5000));
      callback();
    };

    _loop2: for (var _iterator2 = items, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
      var _ref2;

      var _ret = _loop();

      switch (_ret) {
        case 'break':
          break _loop2;

        case 'continue':
          continue;}
    }
  };

  KaLayout.prototype.authorized = function authorized(item) {
    var userGroups = this.api.user.group || this.api.user.groups || [];
    if (!Array.isArray(userGroups)) userGroups = [userGroups];
    return !item.authGroups || item.authGroups && userGroups.some(function (e) {
      return item.authGroups.includes(e);
    });
  };

  KaLayout.prototype.expand = function expand(item) {
    item.collapsed = false;
  };

  KaLayout.prototype.collapse = function collapse(item) {
    item.collapsed = true;
  };

  return KaLayout;
}()) || _class) || _class);