'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KaResource = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11;

var _aureliaFramework = require('aurelia-framework');

var _aureliaRouter = require('aurelia-router');

var _kaToast = require('../ka-toast/ka-toast');

var _kaDialog = require('../ka-dialog/ka-dialog');

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var KaResource = exports.KaResource = (_dec = (0, _aureliaFramework.customElement)('ka-resource'), _dec2 = (0, _aureliaFramework.inject)(Element, _aureliaRouter.Router, _kaToast.KaToast, _kaDialog.KaDialog), _dec3 = (0, _aureliaFramework.bindable)(), _dec4 = (0, _aureliaFramework.bindable)(), _dec5 = (0, _aureliaFramework.bindable)(), _dec6 = (0, _aureliaFramework.bindable)(), _dec7 = (0, _aureliaFramework.bindable)(), _dec8 = (0, _aureliaFramework.bindable)(), _dec9 = (0, _aureliaFramework.bindable)(), _dec10 = (0, _aureliaFramework.bindable)(), _dec11 = (0, _aureliaFramework.bindable)(), _dec12 = (0, _aureliaFramework.bindable)(), _dec13 = (0, _aureliaFramework.bindable)({ defaultBindingMode: _aureliaFramework.bindingMode.fromView }), _dec(_class = _dec2(_class = (_class2 = function () {
  function KaResource(element, router, toast, dialog) {
    var _this = this;

    _classCallCheck(this, KaResource);

    _initDefineProp(this, 'resource', _descriptor, this);

    _initDefineProp(this, 'data', _descriptor2, this);

    _initDefineProp(this, 'schema', _descriptor3, this);

    _initDefineProp(this, 'injectData', _descriptor4, this);

    _initDefineProp(this, 'injectSchema', _descriptor5, this);

    _initDefineProp(this, 'client', _descriptor6, this);

    _initDefineProp(this, 'endpoint', _descriptor7, this);

    _initDefineProp(this, 'disabled', _descriptor8, this);

    _initDefineProp(this, 'controls', _descriptor9, this);

    _initDefineProp(this, 'listRefQuery', _descriptor10, this);

    _initDefineProp(this, 'mode', _descriptor11, this);

    this.readonly = true;
    this.loaded = false;
    this.saveAndReload = false;
    this.errors = [];
    this.hasBeenEdited = false;

    this.schema_loaded = function () {};

    this.data_loaded = function () {};

    this.save_before = function (data) {
      return data;
    };

    this.save_after = function (data) {
      return data;
    };

    this.buttonsActions = {
      prev: function prev() {
        return _this.prev();
      },
      next: function next() {
        return _this.next();
      },
      close: function close() {
        return _this.close();
      },
      edit: function edit() {
        return _this.edit();
      },
      save: function save() {
        return _this.save();
      },
      delete: function _delete() {
        return _this.delete();
      }
    };

    this.element = element;
    this.router = router;
    this.toast = toast;
    this.dialog = dialog;

    this.events = document.createTextNode(null);
    this.events.schemaLoaded = new CustomEvent('schemaLoaded', { resource: this });
    this.events.dataLoaded = new CustomEvent('dataLoaded', { resource: this });
    this.events.dataValidated = new CustomEvent('dataValidated', { resource: this });
    this.events.dataValidateError = new CustomEvent('dataValidateError', { resource: this });
    this.events.dataSaved = new CustomEvent('dataSaved', { resource: this });
    this.events.dataSaveError = new CustomEvent('dataSaveError', { resource: this });
  }

  KaResource.prototype.bind = function bind(bindingContext, overrideContext) {
    this.parentContext = bindingContext;
    this.parentContext.resource = this;
  };

  KaResource.prototype.attached = function attached() {
    this.load();
  };

  KaResource.prototype.modeChanged = function modeChanged(value) {
    switch (value) {
      case 'edit':
        this.disabled = false;
        this._setReadonly(false);
        break;
      case 'readonly':
        this.disabled = true;
        this._setReadonly(true);
        break;
      default:
        this.disabled = false;
        this._setReadonly(true);
        break;
    }
  };

  KaResource.prototype.reload = function reload(resource) {
    this.data = {};

    this.readonly = true;
    this.loaded = false;
    this.errors = [];
    this.resource = resource;
    this.load();
  };

  KaResource.prototype.load = function load() {
    var _this2 = this;

    if (this.parentContext.params && this.parentContext.params.id && this.router.currentInstruction.params && this.router.currentInstruction.params.id && this.parentContext.params.id !== this.router.currentInstruction.params.id) {
      this.saveAndReload = true;
    }
    if (!this.endpoint && this.parentContext.endpoint) this.endpoint = this.parentContext.endpoint;
    if (!this.client && this.parentContext.api && this.parentContext.api.client) this.client = this.parentContext.api.client;
    if (!this.resource && this.parentContext.params && this.parentContext.params.id) this.resource = { id: this.parentContext.params.id };
    if (!this.listRefQuery && this.parentContext.params && this.parentContext.params.listRefQuery) this.listRefQuery = atob(this.parentContext.params.listRefQuery);
    this.modeChanged(this.mode);

    if (this.client && this.endpoint) {
      var endpoint = this.endpoint;
      var dataset = this.endpoint;
      this._request('get', 'datasets/' + dataset).then(function (response) {
        var schema = {};
        for (var _iterator = response, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
          var _ref;

          if (_isArray) {
            if (_i >= _iterator.length) break;
            _ref = _iterator[_i++];
          } else {
            _i = _iterator.next();
            if (_i.done) break;
            _ref = _i.value;
          }

          var item = _ref;
          schema[item.field] = item;
        }_this2.schema = schema;
        _this2.schema_loaded();
        _this2.events.dispatchEvent(_this2.events.schemaLoaded);

        if (_this2.resource && _this2.resource.id === 'new') {
          _this2.originalData = {};
          for (var _iterator2 = Object.keys(_this2.schema), _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
            var _ref2;

            if (_isArray2) {
              if (_i2 >= _iterator2.length) break;
              _ref2 = _iterator2[_i2++];
            } else {
              _i2 = _iterator2.next();
              if (_i2.done) break;
              _ref2 = _i2.value;
            }

            var key = _ref2;
            _this2.originalData[key] = null;
          }_this2.data = JSON.parse(JSON.stringify(_this2.originalData));
          if (_this2.parentContext.params && _this2.parentContext.params.data) _this2.data = Object.assign(_this2.data, _this2.parentContext.params.data);
          _this2.loaded = true;
          _this2.data_loaded();
          _this2.events.dispatchEvent(_this2.events.dataLoaded);
          _this2._setReadonly(false);
        } else if (_this2.resource && _this2.resource.id) {
          _this2._request('get', endpoint + '/' + _this2.resource.id + '?depth=0').then(function (data) {
            _this2.originalData = data;
            _this2.data = JSON.parse(JSON.stringify(_this2.originalData));

            _this2.loaded = true;
            _this2.data_loaded();
            _this2.events.dispatchEvent(_this2.events.dataLoaded);
          });
        }
      });
    } else if (this.injectSchema && this.injectData) {
      var schema = {};
      for (var _iterator3 = this.injectSchema, _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
        var _ref3;

        if (_isArray3) {
          if (_i3 >= _iterator3.length) break;
          _ref3 = _iterator3[_i3++];
        } else {
          _i3 = _iterator3.next();
          if (_i3.done) break;
          _ref3 = _i3.value;
        }

        var item = _ref3;
        schema[item.field] = item;
      }this.schema = schema;

      this.originalData = this.injectData;
      this.data = JSON.parse(JSON.stringify(this.originalData));
      if (this.parentContext.params && this.parentContext.params.data) this.data = Object.assign(this.data, this.parentContext.params.data);
      setTimeout(function () {
        _this2.loaded = true;
        _this2.data_loaded();
        _this2.events.dispatchEvent(_this2.events.dataLoaded);
      }, 500);
    }
  };

  KaResource.prototype.prev = function prev() {
    var _this3 = this;

    var listRefQuery = this.listRefQuery.replace(/offset=(\d+)/, function (match, p1) {
      return 'offset=' + (parseInt(p1, 10) === 0 ? 0 : parseInt(p1, 10) - 1);
    });
    this.client.get('' + listRefQuery).then(function (x) {
      var response = x.response;
      if (!response.length) return _this3.toast.show('Non ci sono record precedenti a questo', 'error');
      if (_this3.parentContext.params.dialog) {
        _this3.listRefQuery = listRefQuery;
        _this3.reload(response[0]);
      } else {
        var route = _this3.router.currentInstruction.config;
        _this3.router.navigateToRoute(route.name, { id: response[0].id, listRefQuery: btoa(listRefQuery) }, { trigger: true, replace: true });
      }
    }).catch(function () {
      _this3.toast.show('Errore nell\'apertura del record precedente', 'error');
    });
  };

  KaResource.prototype.next = function next() {
    var _this4 = this;

    var listRefQuery = this.listRefQuery.replace(/offset=(\d+)/, function (match, p1) {
      return 'offset=' + (parseInt(p1, 10) + 1);
    });
    this.client.get('' + listRefQuery).then(function (x) {
      var response = x.response;
      if (!response.length) return _this4.toast.show('Non ci sono record successivi a questo', 'error');
      if (_this4.parentContext.params.dialog) {
        _this4.listRefQuery = listRefQuery;
        _this4.reload(response[0]);
      } else {
        var route = _this4.router.currentInstruction.config;
        _this4.router.navigateToRoute(route.name, { id: response[0].id, listRefQuery: btoa(listRefQuery) }, { trigger: true, replace: true });
      }
    }).catch(function () {
      _this4.toast.show('Errore nell\'apertura del record successivo', 'error');
    });
  };

  KaResource.prototype.delete = function _delete() {
    var _this5 = this;

    this.dialog.open({
      type: 'confirm',
      class: 'warning',
      title: 'Elimina',
      body: 'Eliminare definitivamente l\'elemento?'
    }, true).whenClosed(function (response) {
      if (!response.wasCancelled) {
        _this5._request('delete', _this5.endpoint + '/' + _this5.resource.id).then(function () {
          if (_this5.parentContext.params.dialog) _this5.parentContext.params.dialog.close(true);else _this5.router.navigate(_this5.router.currentInstruction.config.href);
        });
      }
    });
  };

  KaResource.prototype.edit = function edit() {
    if (this.endpoint) {
      this._setReadonly(false);
    }
  };

  KaResource.prototype.save = function save() {
    var _this6 = this;

    this.errors = this._validateControls().then(function (success) {
      _this6.events.dispatchEvent(_this6.events.dataValidated);
      if (_this6.endpoint) {
        var _ret = function () {
          var promises = [];
          var data = _this6.save_before(_this6.data);
          if (data === false) return {
              v: _this6.data = data
            };
          _this6.data = data;
          data = {};

          var _loop2 = function _loop2() {
            if (_isArray4) {
              if (_i4 >= _iterator4.length) return 'break';
              _ref4 = _iterator4[_i4++];
            } else {
              _i4 = _iterator4.next();
              if (_i4.done) return 'break';
              _ref4 = _i4.value;
            }

            var _ref8 = _ref4,
                field = _ref8[0],
                item = _ref8[1];

            promises.push(new Promise(function (resolve, reject) {
              if (_this6.resource.id && _this6.resource.id !== 'new' && _this6.originalData[field] === item) resolve(true);else if (_this6.controls[field] && (_this6.controls[field].control === 'file' || _this6.controls[field].schema && _this6.controls[field].schema.control === 'file') && item && item.length && item[0] && item[0].name) {
                  var filedata = {};
                  filedata.filename = item[0].name;
                  var reader = new FileReader();
                  reader.readAsDataURL(item[0]);
                  reader.onload = function (x) {
                    filedata.stream = reader.result.indexOf('base64,') ? reader.result.slice(reader.result.indexOf('base64,') + 7) : reader.result;
                    data[field] = filedata;
                    resolve(true);
                  };
                } else if (_this6.controls[field] && (_this6.controls[field].datatype === 'json' || _this6.controls[field].schema && _this6.controls[field].schema.control === 'json') && item && typeof item === 'string') {
                  data[field] = JSON.parse(item);
                  resolve(true);
                } else if (_this6.controls[field] && (_this6.controls[field].control === 'editor' || _this6.controls[field].schema && _this6.controls[field].schema.control === 'editor') && item === '') {
                    data[field] = null;
                    resolve(true);
                  } else {
                    if (typeof item === 'undefined') console.error('Input ' + field + ' has undefined value. Skipping...');else data[field] = JSON.parse(JSON.stringify(item));
                    resolve(true);
                  }
            }));
          };

          for (var _iterator4 = Object.entries(_this6.data), _isArray4 = Array.isArray(_iterator4), _i4 = 0, _iterator4 = _isArray4 ? _iterator4 : _iterator4[Symbol.iterator]();;) {
            var _ref4;

            var _ret3 = _loop2();

            if (_ret3 === 'break') break;
          }
          Promise.all(promises).then(function () {
            var method = 'post';
            var endpoint = _this6.endpoint;
            if (_this6.resource.id && _this6.resource.id !== 'new') {
              delete data.id;
              method = 'patch';
              endpoint = endpoint + '/' + _this6.resource.id;
            }

            var user = _this6.parentContext.api && _this6.parentContext.api.user ? _this6.parentContext.api.user : null;
            if (user && user.groups && user.groups.length) {
              var _loop = function _loop() {
                if (_isArray5) {
                  if (_i5 >= _iterator5.length) return 'break';
                  _ref5 = _iterator5[_i5++];
                } else {
                  _i5 = _iterator5.next();
                  if (_i5.done) return 'break';
                  _ref5 = _i5.value;
                }

                var _ref6 = _ref5,
                    key = _ref6[0],
                    value = _ref6[1];

                if (!_this6.schema[key] || !_this6.schema[key][method]) delete data[key];
                var permissions = _this6.schema[key][method];
                var granted = Object.keys(permissions).filter(function (k) {
                  return (k === '0' || user.groups.includes(k)) && permissions[k] === '1';
                });
                if (!granted || !granted.length) delete data[key];
              };

              for (var _iterator5 = Object.entries(data), _isArray5 = Array.isArray(_iterator5), _i5 = 0, _iterator5 = _isArray5 ? _iterator5 : _iterator5[Symbol.iterator]();;) {
                var _ref5;

                var _ret2 = _loop();

                if (_ret2 === 'break') break;
              }
            }
            if (method === 'patch') {
              data = JSON.parse(JSON.stringify(data));
              if (!data || !Object.keys(data).length) {
                _this6._setReadonly(true);
                _this6.events.dispatchEvent(_this6.events.dataSaved);
                return;
              }
            }
            _this6.hasBeenEdited = true;
            _this6._request(method, endpoint, data).then(function (response) {
              _this6._setReadonly(true);
              data = Object.assign(_this6.originalData, data);
              data.id = response.id || _this6.resource.id;
              _this6.data = _this6.save_after(data);
              _this6.events.dispatchEvent(_this6.events.dataSaved);
              _this6.originalData = JSON.parse(JSON.stringify(data));
              if (_this6.data === false) return _this6.data = data;

              var route = _this6.router.currentInstruction.config;
              if (_this6.resource.id === 'new') {
                _this6.toast.show('Record creato!', 'success');
                if (_this6.parentContext.params.dialog || _this6.saveAndReload) {
                  _this6.reload(response);
                } else {
                  _this6.router.navigateToRoute(route.name, { id: response.id || _this6.resource.id, listRefQuery: _this6.listRefQuery ? btoa(_this6.listRefQuery) : null }, { trigger: true, replace: true });
                }
              } else {
                _this6.toast.show('Record aggiornato!', 'success');
                if (_this6.parentContext.params.dialog || _this6.saveAndReload) {
                  _this6.resource.id = response.id || _this6.resource.id;
                  _this6.modeChanged(_this6.mode);
                } else {
                  _this6.router.navigateToRoute(route.name, { id: response.id || _this6.resource.id, listRefQuery: _this6.listRefQuery ? btoa(_this6.listRefQuery) : null }, { trigger: true, replace: true });
                }
              }
            }, function (error) {
              console.warn('error', error);
              error = JSON.parse(error.response);
              _this6.events.dispatchEvent(_this6.events.dataSaveError);
              if (error.errors) {
                for (var _iterator6 = error.errors, _isArray6 = Array.isArray(_iterator6), _i6 = 0, _iterator6 = _isArray6 ? _iterator6 : _iterator6[Symbol.iterator]();;) {
                  var _ref7;

                  if (_isArray6) {
                    if (_i6 >= _iterator6.length) break;
                    _ref7 = _iterator6[_i6++];
                  } else {
                    _i6 = _iterator6.next();
                    if (_i6.done) break;
                    _ref7 = _i6.value;
                  }

                  var err = _ref7;

                  if (err.arg && Array.isArray(err.arg) && err.arg[0]) _this6.toast.show('<strong>' + _this6.schema[err.arg[0]].label + '</strong>: ' + err.msg, 'error');else if (err.arg && _typeof(err.arg) === 'object') _this6.toast.show('<strong>' + _this6.schema[Object.keys(err.arg)[0]].label + '</strong>: ' + err.msg, 'error');else if (err.message) {
                      var message = (err.data && _this6.schema[err.data] ? '<strong>' + _this6.schema[err.data].label + '</strong>: ' : '') + err.message;
                      _this6.toast.show(message, 'error');
                    }
                }
              }
            });
          });
        }();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      }
    }, function (response) {
      _this6.events.dispatchEvent(_this6.events.dataValidateError);
      if (response.length) {
        for (var _iterator7 = response, _isArray7 = Array.isArray(_iterator7), _i7 = 0, _iterator7 = _isArray7 ? _iterator7 : _iterator7[Symbol.iterator]();;) {
          var _ref9;

          if (_isArray7) {
            if (_i7 >= _iterator7.length) break;
            _ref9 = _iterator7[_i7++];
          } else {
            _i7 = _iterator7.next();
            if (_i7.done) break;
            _ref9 = _i7.value;
          }

          var errors = _ref9;

          for (var _iterator8 = errors, _isArray8 = Array.isArray(_iterator8), _i8 = 0, _iterator8 = _isArray8 ? _iterator8 : _iterator8[Symbol.iterator]();;) {
            var _ref10;

            if (_isArray8) {
              if (_i8 >= _iterator8.length) break;
              _ref10 = _iterator8[_i8++];
            } else {
              _i8 = _iterator8.next();
              if (_i8.done) break;
              _ref10 = _i8.value;
            }

            var error = _ref10;

            if (!error.valid) _this6.toast.show('<strong>' + error.object.label + '</strong>: ' + error.message, 'error');
          }
        }
      }
    });
  };

  KaResource.prototype.close = function close() {
    var route = this.router.currentInstruction.config;
    if (this.readonly || this.resource.id === 'new') {
      if (this.parentContext.params.dialog) {
        var ok = this.hasBeenEdited === true;
        this.parentContext.params.dialog.close(ok, ok && this.originalData ? this.originalData : null);
        return;
      }
      this.router.navigate(route.href);
      return;
    }
    this.data = JSON.parse(JSON.stringify(this.originalData));
    this._setReadonly(true);
  };

  KaResource.prototype._validateControls = function _validateControls() {
    for (var index in this.tabs) {
      this.tabs[index].errors = [];
    }var promises = [];

    var _loop3 = function _loop3() {
      if (_isArray9) {
        if (_i9 >= _iterator9.length) return 'break';
        _ref11 = _iterator9[_i9++];
      } else {
        _i9 = _iterator9.next();
        if (_i9.done) return 'break';
        _ref11 = _i9.value;
      }

      var _ref12 = _ref11,
          field = _ref12[0],
          item = _ref12[1];

      var promise = item.validate().then(function (result) {
        if (!result.valid) {
          var errors = [];
          for (var _iterator10 = item.validator.errors, _isArray10 = Array.isArray(_iterator10), _i10 = 0, _iterator10 = _isArray10 ? _iterator10 : _iterator10[Symbol.iterator]();;) {
            var _ref13;

            if (_isArray10) {
              if (_i10 >= _iterator10.length) break;
              _ref13 = _iterator10[_i10++];
            } else {
              _i10 = _iterator10.next();
              if (_i10.done) break;
              _ref13 = _i10.value;
            }

            var error = _ref13;

            error.tab = item.parentTab;

            errors.push(error);
          }
          return Promise.reject(errors);
        }
        return Promise.resolve(result);
      });
      if (item.validator) promises.push(promise);
    };

    for (var _iterator9 = Object.entries(this.controls), _isArray9 = Array.isArray(_iterator9), _i9 = 0, _iterator9 = _isArray9 ? _iterator9 : _iterator9[Symbol.iterator]();;) {
      var _ref11;

      var _ret4 = _loop3();

      if (_ret4 === 'break') break;
    }
    return this.promiseAll(promises);
  };

  KaResource.prototype._resetButtons = function _resetButtons() {
    var _this7 = this;

    var buttons = [];
    if ((this.disabled || this.readonly) && this.listRefQuery) {
      buttons.push({ action: function action() {
          return _this7.buttonsActions.prev();
        }, label: 'Record precedente', icon: 'keyboard_arrow_left' });
      buttons.push({ action: function action() {
          return _this7.buttonsActions.next();
        }, label: 'Record seguente', icon: 'keyboard_arrow_right' });
    }
    if (this.client && !this.disabled) {
      if ((!this.resource.id || this.resource.id !== 'new') && this.readonly) {
        buttons.push({ action: function action() {
            return _this7.buttonsActions.delete();
          }, label: 'Elimina', icon: '&#xE92B;' });
      }
      if (this.readonly) {
        buttons.push({ action: function action() {
            return _this7.buttonsActions.edit();
          }, label: 'Modifica', icon: '&#xE3C9;' });
      } else {
        buttons.push({ action: function action() {
            return _this7.buttonsActions.save();
          }, label: 'Salva', icon: '&#xE5CA;' });
      }
    }
    buttons.push({ action: function action() {
        return _this7.buttonsActions.close();
      }, label: 'Chiudi', icon: '&#xE14C;' });
    this.buttons = buttons;
  };

  KaResource.prototype._setReadonly = function _setReadonly(value) {
    this.readonly = value;
    this._resetButtons();
  };

  KaResource.prototype._request = function _request(method, url) {
    var data = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    if (!this.client) return Promise.reject('Missing HTTP client.');
    method = method.toLowerCase();
    if (!this.client[method]) return Promise.reject('Unknown HTTP method.');
    return this.client[method](url, data).then(function (x) {
      return Promise.resolve(x.response);
    }).catch(function (x) {
      return Promise.reject(x);
    });
  };

  KaResource.prototype.promiseAll = function promiseAll(promises) {
    var count = 0;
    var errors = [];
    var results = [];
    var promise = new Promise(function (resolve, reject) {
      for (var _iterator11 = promises, _isArray11 = Array.isArray(_iterator11), _i11 = 0, _iterator11 = _isArray11 ? _iterator11 : _iterator11[Symbol.iterator]();;) {
        var _ref14;

        if (_isArray11) {
          if (_i11 >= _iterator11.length) break;
          _ref14 = _iterator11[_i11++];
        } else {
          _i11 = _iterator11.next();
          if (_i11.done) break;
          _ref14 = _i11.value;
        }

        var p = _ref14;

        p.then(function (success) {
          count++;
          results.push(success);
          if (count === promises.length) {
            if (errors.length) reject(errors);else resolve(results);
          }
          return success;
        }, function (error) {
          count++;
          errors.push(error);
          if (count === promises.length) {
            if (errors.length) reject(errors);else resolve(results);
          }
          return error;
        });
      }
    });
    return promise;
  };

  return KaResource;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'resource', [_dec3], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'data', [_dec4], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec5], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'injectData', [_dec6], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'injectSchema', [_dec7], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, 'client', [_dec8], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, 'endpoint', [_dec9], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, 'disabled', [_dec10], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, 'controls', [_dec11], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, 'listRefQuery', [_dec12], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, 'mode', [_dec13], {
  enumerable: true,
  initializer: function initializer() {
    return 'normal';
  }
})), _class2)) || _class) || _class);