'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var KaToast = exports.KaToast = function () {
  function KaToast() {
    _classCallCheck(this, KaToast);

    this.duration = 4000;
    this.transition = 500;
    this.hold = false;
    this.stack = [];
  }

  KaToast.prototype.show = function show(message, elementClass) {
    var hold = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    message = message || '';
    elementClass = elementClass || '';
    this.stack.push({ message: message, elementClass: elementClass, hold: hold });
    this.consume();
  };

  KaToast.prototype.consume = function consume() {
    var _this = this;

    if (this.holdedElement) {
      this.holdedElement.remove();
      this.hold = false;
      this.holdedElement = null;
    }
    if (this.stack.length && !this.hold) {
      this.hold = true;
      var current = this.stack.shift();
      var element = document.createElement('div');
      element.classList.add('ka-toast');
      element.classList.add('ka-toast-' + current.elementClass);
      element.innerHTML = current.message;
      document.body.append(element);

      setTimeout(function () {
        element.classList.add('visible');
      }, this.transition);

      if (!current.hold) {
        this.holdedElement = null;
        setTimeout(function () {
          element.classList.remove('visible');
          setTimeout(function () {
            element.remove();
            _this.hold = false;
            _this.consume();
          }, _this.transition);
        }, this.duration - this.transition);
      } else {
        this.holdedElement = element;
      }
    }
  };

  return KaToast;
}();