var _dec, _dec2, _dec3, _dec4, _dec5, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import { inject, customElement, bindable, bindingMode } from 'aurelia-framework';
import ClassicEditor from 'ka-ckeditor';

export let KaControlEditor = (_dec = customElement('ka-control-editor'), _dec2 = inject(Element), _dec3 = bindable(), _dec4 = bindable({ defaultBindingMode: bindingMode.twoWay }), _dec5 = bindable(), _dec(_class = _dec2(_class = (_class2 = class KaControlEditor {

  constructor(element) {
    _initDefineProp(this, 'schema', _descriptor, this);

    _initDefineProp(this, 'value', _descriptor2, this);

    _initDefineProp(this, 'readonly', _descriptor3, this);

    this.element = element;
  }

  attached() {}

  schemaChanged(schema) {
    if (!schema) {
      konsole.warn('ka-control-editor: missing schema!', schema);
      return;
    }
    if (typeof schema === 'string') {
      try {
        schema = JSON.parse(schema);
      } catch (error) {
        konsole.error('ka-control-editor: invalid schema provided!', schema);
        return;
      }
    }

    for (let attribute of ['readonly']) {
      if (this[attribute] === null) {
        if (this.element.getAttribute(attribute)) {
          this[attribute] = String(this.element.getAttribute(attribute)).toLowerCase() === 'true';
        } else if (typeof schema[attribute] !== undefined) {
          this[attribute] = String(schema[attribute]).toLowerCase() === 'true';
        }
      } else this[attribute] = String(this[attribute]).toLowerCase() === 'true';
    }

    konsole.debug('ka-control-editor: schema changed!', schema);
    this._schema = schema;

    this.buildEditor();
  }

  valueChanged(value) {
    if (!this.editor || this.editorValuePending || this.editor.getData() === value) return;
    konsole.debug('ka-control-editor: value changed!', value);
    this.editorValuePending = true;
    this.editor.setData(value || '');
    setTimeout(() => {
      this.editorValuePending = false;
    }, 0);
  }

  readonlyChanged(readonly) {
    if (this.editor) this.editor.isReadOnly = readonly;
  }

  buildEditor() {
    if (this._editor_initialized) return;
    let config = {
      toolbar: {
        items: ['heading', '|', 'bold', 'italic', 'strikethrough', 'superscript', 'subscript', 'removeFormat', '|', 'bulletedList', 'numberedList', '|', 'alignment', 'indent', 'outdent', '|', 'link', 'imageUpload', 'blockQuote', 'insertTable', 'mediaEmbed', 'undo', 'redo', '|', 'code']
      },
      language: 'it',
      image: {
        toolbar: ['imageTextAlternative', 'imageStyle:full', 'imageStyle:side']
      },
      table: {
        contentToolbar: ['tableColumn', 'tableRow', 'mergeTableCells']
      }
    };
    ClassicEditor.create(this.element, config).then(editor => {
      editor.setData(this.value || '');
      editor.isReadOnly = this.readonly;
      editor.model.document.on('change:data', () => {
        this.value = editor.getData();
      });
      this.editor = editor;
    }).catch(error => {
      konsole.error('There was a problem initializing ckeditor', error);
    }).finally(() => {
      this._editor_initialized = true;
    });
  }
}, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec3], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'value', [_dec4], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'readonly', [_dec5], {
  enumerable: true,
  initializer: function () {
    return null;
  }
})), _class2)) || _class) || _class);