var _dec, _dec2, _dec3, _dec4, _dec5, _class, _desc, _value2, _class2, _descriptor, _descriptor2, _descriptor3;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import { inject, customElement, bindable, bindingMode } from 'aurelia-framework';

export let KaControlsList = (_dec = customElement('ka-control-list'), _dec2 = inject(Element), _dec3 = bindable(), _dec4 = bindable({ defaultBindingMode: bindingMode.twoWay }), _dec5 = bindable(), _dec(_class = _dec2(_class = (_class2 = class KaControlsList {

  constructor(element) {
    _initDefineProp(this, 'schema', _descriptor, this);

    _initDefineProp(this, 'value', _descriptor2, this);

    _initDefineProp(this, 'readonly', _descriptor3, this);

    this._schema = null;
    this._value = [];
    this.newValue = {};

    this.element = element;
  }

  attached() {
    if (!this.value) this.add();
  }

  schemaChanged(schema) {
    if (!schema) {
      konsole.warn('ka-control-list: missing schema!', schema);
      return;
    }
    if (typeof schema === 'string') {
      try {
        schema = JSON.parse(schema);
      } catch (error) {
        konsole.error('ka-control-list: invalid schema provided!', value);
        return;
      }
    }
    if (!schema.datasource) {
      konsole.error('ka-control-list: missing datasource in schema!', schema);
      return;
    }
    if (typeof schema.datasource === 'string') {
      try {
        schema.datasource = JSON.parse(schema.datasource);
      } catch (error) {
        konsole.error('ka-control-list: invalid datasource provided in schema!', schema);
        return;
      }
    }
    if (!schema.datasource.model) {
      konsole.error('ka-control-list: model missing from datasource!', schema.datasource);
      return;
    }
    if (!schema.datasource.model.schema) {
      konsole.error('ka-control-list: schema missing from datasource model!', schema.datasource.model);
      return;
    }
    if (!Array.isArray(schema.datasource.model.schema) || !schema.datasource.model.schema.length) {
      konsole.error('ka-control-list: datasource model schema must be an array of objects!', schema.datasource.model);
      return;
    }

    for (let attribute of ['readonly']) {
      if (this[attribute] === null) {
        if (this.element.getAttribute(attribute)) {
          this[attribute] = String(this.element.getAttribute(attribute)).toLowerCase() === 'true';
        } else if (typeof schema[attribute] !== undefined) {
          this[attribute] = String(schema[attribute]).toLowerCase() === 'true';
        }
      } else this[attribute] = String(this[attribute]).toLowerCase() === 'true';
    }

    konsole.debug('ka-control-list: schema changed!', schema);
    this._schema = schema;
  }

  keydown() {
    return !this.readonly;
  }

  change() {
    if (!this._value.map(x => Object.values(x).join('')).join('').length) {
      this.value = null;
    } else {
      this.value = JSON.stringify(this._value);
    }
  }

  valueChanged(value) {
    if (!this._schema) {
      konsole.warn('ka-control-combo: cannot handle value without schema!');
      return;
    }

    if (!value || value === JSON.stringify(this._value)) {
      return;
    }
    let _value = value;
    if (typeof _value === 'string') {
      try {
        _value = JSON.parse(_value);
      } catch (error) {
        konsole.error('ka-control-list: invalid value provided!', value);
        return;
      }
    }
    if (!Array.isArray(_value)) {
      konsole.error('ka-control-list: value must be an array!', value);
      return;
    }
    if (!_value.length) {
      if (!this._value.length) this.add();
      return;
    }

    konsole.debug('ka-control-list: value changed!', _value);
    this._value = _value;
  }

  add() {
    let value = {};
    for (let schema of this._schema.datasource.model.schema) {
      value[schema.field] = null;
    }
    this._value.push(value);
  }

  remove(value) {
    this._value = this._value.filter(v => v !== value);
    this.change();
  }
}, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec3], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'value', [_dec4], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'readonly', [_dec5], {
  enumerable: true,
  initializer: function () {
    return null;
  }
})), _class2)) || _class) || _class);