var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import { bindable, bindingMode, customElement, inject } from 'aurelia-framework';
import { Router } from 'aurelia-router';
import { KaToast } from '../ka-toast/ka-toast';
import { KaDialog } from '../ka-dialog/ka-dialog';

export let KaResource = (_dec = customElement('ka-resource'), _dec2 = inject(Element, Router, KaToast, KaDialog), _dec3 = bindable(), _dec4 = bindable(), _dec5 = bindable(), _dec6 = bindable(), _dec7 = bindable(), _dec8 = bindable(), _dec9 = bindable(), _dec10 = bindable(), _dec11 = bindable(), _dec12 = bindable(), _dec13 = bindable({ defaultBindingMode: bindingMode.fromView }), _dec(_class = _dec2(_class = (_class2 = class KaResource {

  constructor(element, router, toast, dialog) {
    _initDefineProp(this, 'resource', _descriptor, this);

    _initDefineProp(this, 'data', _descriptor2, this);

    _initDefineProp(this, 'schema', _descriptor3, this);

    _initDefineProp(this, 'injectData', _descriptor4, this);

    _initDefineProp(this, 'injectSchema', _descriptor5, this);

    _initDefineProp(this, 'client', _descriptor6, this);

    _initDefineProp(this, 'endpoint', _descriptor7, this);

    _initDefineProp(this, 'disabled', _descriptor8, this);

    _initDefineProp(this, 'controls', _descriptor9, this);

    _initDefineProp(this, 'listRefQuery', _descriptor10, this);

    _initDefineProp(this, 'mode', _descriptor11, this);

    this.readonly = true;
    this.loaded = false;
    this.saveAndReload = false;
    this.errors = [];
    this.hasBeenEdited = false;

    this.schema_loaded = () => {};

    this.data_loaded = () => {};

    this.save_before = data => {
      return data;
    };

    this.save_after = data => {
      return data;
    };

    this.buttonsActions = {
      prev: () => {
        return this.prev();
      },
      next: () => {
        return this.next();
      },
      close: () => {
        return this.close();
      },
      edit: () => {
        return this.edit();
      },
      save: () => {
        return this.save();
      },
      delete: () => {
        return this.delete();
      }
    };

    this.element = element;
    this.router = router;
    this.toast = toast;
    this.dialog = dialog;

    this.events = document.createTextNode(null);
    this.events.schemaLoaded = new CustomEvent('schemaLoaded', { resource: this });
    this.events.dataLoaded = new CustomEvent('dataLoaded', { resource: this });
    this.events.dataValidated = new CustomEvent('dataValidated', { resource: this });
    this.events.dataValidateError = new CustomEvent('dataValidateError', { resource: this });
    this.events.dataSaved = new CustomEvent('dataSaved', { resource: this });
    this.events.dataSaveError = new CustomEvent('dataSaveError', { resource: this });
  }

  bind(bindingContext, overrideContext) {
    this.parentContext = bindingContext;
    this.parentContext.resource = this;
  }

  attached() {
    this.load();
  }

  modeChanged(value) {
    switch (value) {
      case 'edit':
        this.disabled = false;
        this._setReadonly(false);
        break;
      case 'readonly':
        this.disabled = true;
        this._setReadonly(true);
        break;
      default:
        this.disabled = false;
        this._setReadonly(true);
        break;
    }
  }

  reload(resource) {
    this.data = {};

    this.readonly = true;
    this.loaded = false;
    this.errors = [];
    this.resource = resource;
    this.load();
  }
  load() {
    if (this.parentContext.params && this.parentContext.params.id && this.router.currentInstruction.params && this.router.currentInstruction.params.id && this.parentContext.params.id !== this.router.currentInstruction.params.id) {
      this.saveAndReload = true;
    }
    if (!this.endpoint && this.parentContext.endpoint) this.endpoint = this.parentContext.endpoint;
    if (!this.client && this.parentContext.api && this.parentContext.api.client) this.client = this.parentContext.api.client;
    if (!this.resource && this.parentContext.params && this.parentContext.params.id) this.resource = { id: this.parentContext.params.id };
    if (!this.listRefQuery && this.parentContext.params && this.parentContext.params.listRefQuery) this.listRefQuery = atob(this.parentContext.params.listRefQuery);
    this.modeChanged(this.mode);

    if (this.client && this.endpoint) {
      let endpoint = this.endpoint;
      let dataset = this.endpoint;
      this._request('get', `datasets/${dataset}`).then(response => {
        let schema = {};
        for (let item of response) schema[item.field] = item;
        this.schema = schema;
        this.schema_loaded();
        this.events.dispatchEvent(this.events.schemaLoaded);

        if (this.resource && this.resource.id === 'new') {
          this.originalData = {};
          for (let key of Object.keys(this.schema)) this.originalData[key] = null;
          this.data = JSON.parse(JSON.stringify(this.originalData));
          if (this.parentContext.params && this.parentContext.params.data) this.data = Object.assign(this.data, this.parentContext.params.data);
          this.loaded = true;
          this.data_loaded();
          this.events.dispatchEvent(this.events.dataLoaded);
          this._setReadonly(false);
        } else if (this.resource && this.resource.id) {
          this._request('get', `${endpoint}/${this.resource.id}?depth=0`).then(data => {
            this.originalData = data;
            this.data = JSON.parse(JSON.stringify(this.originalData));

            this.loaded = true;
            this.data_loaded();
            this.events.dispatchEvent(this.events.dataLoaded);
          });
        }
      });
    } else if (this.injectSchema && this.injectData) {
      let schema = {};
      for (let item of this.injectSchema) schema[item.field] = item;
      this.schema = schema;

      this.originalData = this.injectData;
      this.data = JSON.parse(JSON.stringify(this.originalData));
      if (this.parentContext.params && this.parentContext.params.data) this.data = Object.assign(this.data, this.parentContext.params.data);
      setTimeout(() => {
        this.loaded = true;
        this.data_loaded();
        this.events.dispatchEvent(this.events.dataLoaded);
      }, 500);
    }
  }

  prev() {
    let listRefQuery = this.listRefQuery.replace(/offset=(\d+)/, (match, p1) => {
      return `offset=${parseInt(p1, 10) === 0 ? 0 : parseInt(p1, 10) - 1}`;
    });
    this.client.get(`${listRefQuery}`).then(x => {
      let response = x.response;
      if (!response.length) return this.toast.show('Non ci sono record precedenti a questo', 'error');
      if (this.parentContext.params.dialog) {
        this.listRefQuery = listRefQuery;
        this.reload(response[0]);
      } else {
        let route = this.router.currentInstruction.config;
        this.router.navigateToRoute(route.name, { id: response[0].id, listRefQuery: btoa(listRefQuery) }, { trigger: true, replace: true });
      }
    }).catch(() => {
      this.toast.show('Errore nell\'apertura del record precedente', 'error');
    });
  }

  next() {
    let listRefQuery = this.listRefQuery.replace(/offset=(\d+)/, (match, p1) => {
      return `offset=${parseInt(p1, 10) + 1}`;
    });
    this.client.get(`${listRefQuery}`).then(x => {
      let response = x.response;
      if (!response.length) return this.toast.show('Non ci sono record successivi a questo', 'error');
      if (this.parentContext.params.dialog) {
        this.listRefQuery = listRefQuery;
        this.reload(response[0]);
      } else {
        let route = this.router.currentInstruction.config;
        this.router.navigateToRoute(route.name, { id: response[0].id, listRefQuery: btoa(listRefQuery) }, { trigger: true, replace: true });
      }
    }).catch(() => {
      this.toast.show('Errore nell\'apertura del record successivo', 'error');
    });
  }

  delete() {
    this.dialog.open({
      type: 'confirm',
      class: 'warning',
      title: 'Elimina',
      body: 'Eliminare definitivamente l\'elemento?'
    }, true).whenClosed(response => {
      if (!response.wasCancelled) {
        this._request('delete', `${this.endpoint}/${this.resource.id}`).then(() => {
          if (this.parentContext.params.dialog) this.parentContext.params.dialog.close(true);else this.router.navigate(this.router.currentInstruction.config.href);
        });
      }
    });
  }

  edit() {
    if (this.endpoint) {
      this._setReadonly(false);
    }
  }

  save() {
    this.errors = this._validateControls().then(success => {
      this.events.dispatchEvent(this.events.dataValidated);
      if (this.endpoint) {
        let promises = [];
        let data = this.save_before(this.data);
        if (data === false) return this.data = data;
        this.data = data;
        data = {};
        for (let [field, item] of Object.entries(this.data)) {
          promises.push(new Promise((resolve, reject) => {
            if (this.resource.id && this.resource.id !== 'new' && this.originalData[field] === item) resolve(true);else if (this.controls[field] && (this.controls[field].control === 'file' || this.controls[field].schema && this.controls[field].schema.control === 'file') && item && item.length && item[0] && item[0].name) {
                let filedata = {};
                filedata.filename = item[0].name;
                let reader = new FileReader();
                reader.readAsDataURL(item[0]);
                reader.onload = x => {
                  filedata.stream = reader.result.indexOf('base64,') ? reader.result.slice(reader.result.indexOf('base64,') + 7) : reader.result;
                  data[field] = filedata;
                  resolve(true);
                };
              } else if (this.controls[field] && (this.controls[field].datatype === 'json' || this.controls[field].schema && this.controls[field].schema.control === 'json') && item && typeof item === 'string') {
                data[field] = JSON.parse(item);
                resolve(true);
              } else if (this.controls[field] && (this.controls[field].control === 'editor' || this.controls[field].schema && this.controls[field].schema.control === 'editor') && item === '') {
                  data[field] = null;
                  resolve(true);
                } else {
                  if (typeof item === 'undefined') console.error(`Input ${field} has undefined value. Skipping...`);else data[field] = JSON.parse(JSON.stringify(item));
                  resolve(true);
                }
          }));
        }
        Promise.all(promises).then(() => {
          let method = 'post';
          let endpoint = this.endpoint;
          if (this.resource.id && this.resource.id !== 'new') {
            delete data.id;
            method = 'patch';
            endpoint = `${endpoint}/${this.resource.id}`;
          }

          let user = this.parentContext.api && this.parentContext.api.user ? this.parentContext.api.user : null;
          if (user && user.groups && user.groups.length) {
            for (let [key, value] of Object.entries(data)) {
              if (!this.schema[key] || !this.schema[key][method]) delete data[key];
              let permissions = this.schema[key][method];
              let granted = Object.keys(permissions).filter(k => {
                return (k === '0' || user.groups.includes(k)) && permissions[k] === '1';
              });
              if (!granted || !granted.length) delete data[key];
            }
          }
          if (method === 'patch') {
            data = JSON.parse(JSON.stringify(data));
            if (!data || !Object.keys(data).length) {
              this._setReadonly(true);
              this.events.dispatchEvent(this.events.dataSaved);
              return;
            }
          }
          this.hasBeenEdited = true;
          this._request(method, endpoint, data).then(response => {
            this._setReadonly(true);
            data = Object.assign(this.originalData, data);
            data.id = response.id || this.resource.id;
            this.data = this.save_after(data);
            this.events.dispatchEvent(this.events.dataSaved);
            this.originalData = JSON.parse(JSON.stringify(data));
            if (this.data === false) return this.data = data;

            let route = this.router.currentInstruction.config;
            if (this.resource.id === 'new') {
              this.toast.show('Record creato!', 'success');
              if (this.parentContext.params.dialog || this.saveAndReload) {
                this.reload(response);
              } else {
                this.router.navigateToRoute(route.name, { id: response.id || this.resource.id, listRefQuery: this.listRefQuery ? btoa(this.listRefQuery) : null }, { trigger: true, replace: true });
              }
            } else {
              this.toast.show('Record aggiornato!', 'success');
              if (this.parentContext.params.dialog || this.saveAndReload) {
                this.resource.id = response.id || this.resource.id;
                this.modeChanged(this.mode);
              } else {
                this.router.navigateToRoute(route.name, { id: response.id || this.resource.id, listRefQuery: this.listRefQuery ? btoa(this.listRefQuery) : null }, { trigger: true, replace: true });
              }
            }
          }, error => {
            console.warn('error', error);
            error = JSON.parse(error.response);
            this.events.dispatchEvent(this.events.dataSaveError);
            if (error.errors) {
              for (let err of error.errors) {
                if (err.arg && Array.isArray(err.arg) && err.arg[0]) this.toast.show(`<strong>${this.schema[err.arg[0]].label}</strong>: ${err.msg}`, 'error');else if (err.arg && typeof err.arg === 'object') this.toast.show(`<strong>${this.schema[Object.keys(err.arg)[0]].label}</strong>: ${err.msg}`, 'error');else if (err.message) {
                    let message = (err.data && this.schema[err.data] ? `<strong>${this.schema[err.data].label}</strong>: ` : '') + err.message;
                    this.toast.show(message, 'error');
                  }
              }
            }
          });
        });
      }
    }, response => {
      this.events.dispatchEvent(this.events.dataValidateError);
      if (response.length) {
        for (let errors of response) {
          for (let error of errors) {
            if (!error.valid) this.toast.show(`<strong>${error.object.label}</strong>: ${error.message}`, 'error');
          }
        }
      }
    });
  }

  close() {
    let route = this.router.currentInstruction.config;
    if (this.readonly || this.resource.id === 'new') {
      if (this.parentContext.params.dialog) {
        let ok = this.hasBeenEdited === true;
        this.parentContext.params.dialog.close(ok, ok && this.originalData ? this.originalData : null);
        return;
      }
      this.router.navigate(route.href);
      return;
    }
    this.data = JSON.parse(JSON.stringify(this.originalData));
    this._setReadonly(true);
  }

  _validateControls() {
    for (let index in this.tabs) this.tabs[index].errors = [];
    let promises = [];
    for (let [field, item] of Object.entries(this.controls)) {
      let promise = item.validate().then(result => {
        if (!result.valid) {
          let errors = [];
          for (let error of item.validator.errors) {
            error.tab = item.parentTab;

            errors.push(error);
          }
          return Promise.reject(errors);
        }
        return Promise.resolve(result);
      });
      if (item.validator) promises.push(promise);
    }
    return this.promiseAll(promises);
  }

  _resetButtons() {
    let buttons = [];
    if ((this.disabled || this.readonly) && this.listRefQuery) {
      buttons.push({ action: () => this.buttonsActions.prev(), label: 'Record precedente', icon: 'keyboard_arrow_left' });
      buttons.push({ action: () => this.buttonsActions.next(), label: 'Record seguente', icon: 'keyboard_arrow_right' });
    }
    if (this.client && !this.disabled) {
      if ((!this.resource.id || this.resource.id !== 'new') && this.readonly) {
        buttons.push({ action: () => this.buttonsActions.delete(), label: 'Elimina', icon: '&#xE92B;' });
      }
      if (this.readonly) {
        buttons.push({ action: () => this.buttonsActions.edit(), label: 'Modifica', icon: '&#xE3C9;' });
      } else {
        buttons.push({ action: () => this.buttonsActions.save(), label: 'Salva', icon: '&#xE5CA;' });
      }
    }
    buttons.push({ action: () => this.buttonsActions.close(), label: 'Chiudi', icon: '&#xE14C;' });
    this.buttons = buttons;
  }

  _setReadonly(value) {
    this.readonly = value;
    this._resetButtons();
  }

  _request(method, url, data = {}) {
    if (!this.client) return Promise.reject('Missing HTTP client.');
    method = method.toLowerCase();
    if (!this.client[method]) return Promise.reject('Unknown HTTP method.');
    return this.client[method](url, data).then(x => {
      return Promise.resolve(x.response);
    }).catch(x => {
      return Promise.reject(x);
    });
  }

  promiseAll(promises) {
    let count = 0;
    let errors = [];
    let results = [];
    let promise = new Promise((resolve, reject) => {
      for (let p of promises) {
        p.then(success => {
          count++;
          results.push(success);
          if (count === promises.length) {
            if (errors.length) reject(errors);else resolve(results);
          }
          return success;
        }, error => {
          count++;
          errors.push(error);
          if (count === promises.length) {
            if (errors.length) reject(errors);else resolve(results);
          }
          return error;
        });
      }
    });
    return promise;
  }

}, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'resource', [_dec3], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'data', [_dec4], {
  enumerable: true,
  initializer: function () {
    return {};
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec5], {
  enumerable: true,
  initializer: function () {
    return {};
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'injectData', [_dec6], {
  enumerable: true,
  initializer: function () {
    return {};
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'injectSchema', [_dec7], {
  enumerable: true,
  initializer: function () {
    return {};
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, 'client', [_dec8], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, 'endpoint', [_dec9], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, 'disabled', [_dec10], {
  enumerable: true,
  initializer: function () {
    return false;
  }
}), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, 'controls', [_dec11], {
  enumerable: true,
  initializer: function () {
    return {};
  }
}), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, 'listRefQuery', [_dec12], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, 'mode', [_dec13], {
  enumerable: true,
  initializer: function () {
    return 'normal';
  }
})), _class2)) || _class) || _class);