var _dec, _dec2, _class;

import { inject, customElement } from 'aurelia-framework';
import { Router } from 'aurelia-router';

export let KaTabs = (_dec = customElement('ka-tabs'), _dec2 = inject(Element, Router), _dec(_class = _dec2(_class = class KaTabs {

  constructor(element, router) {
    this.tabs = [];

    this.element = element;
    this.name = 'ka-tab-' + this.element.id;
    this.router = router;
  }

  bind(bindingContext, overrideContext) {
    this.parent = bindingContext;
  }

  attached() {
    this.init().then(tabs => {
      let tab = tabs[0];
      let queryParams = this.router.currentInstruction.queryParams;
      if (queryParams[this.name]) tab = this.tabs.find(item => item.name === queryParams[this.name]) || tab;
      this.select(tab);
    });
    this.element.style.display = 'block';
    this.contents.style.display = 'block';
    this.contents.style.position = 'relative';
    this.contents.style.width = '100%';
    this.contents.style.whiteSpace = 'nowrap';
    this.contents.style.overflow = 'hidden';
  }

  get current() {
    return this.tabs.find(item => item.visible);
  }

  init() {
    this.tabs = [];
    return new Promise((resolve, reject) => {
      let elements = Array.from(this.contents.children).filter(x => x.matches('ka-tab'));
      for (let element of elements) {
        element.style.opacity = '0';
        element.style.width = '100%';
        element.style.position = 'absolute';
        element.style.top = '0';
        element.style.left = '0';
        element.style.transition = 'left 0.3s ease-in-out';
        this.tabs.push({
          element,
          label: element.getAttribute('label') || element.id || 'tab-' + elements.indexOf(element),
          name: element.id,
          readonly: true,
          visible: false
        });
      }
      resolve(this.tabs);
    });
  }

  isDialog() {
    return this.parent && this.parent.params && this.parent.params.dialog;
  }

  select(tab) {
    let currentTab = this.current;
    let current = this.tabs.indexOf(currentTab);
    let index = this.tabs.indexOf(tab);

    if (tab.element.id && !this.isDialog()) {
      let queryParams = Object.assign({}, this.router.currentInstruction.params, this.router.currentInstruction.queryParams);
      let route = this.router.currentInstruction.config;
      queryParams[this.name] = tab.name;
      this.router.navigateToRoute(route.name, queryParams, { trigger: false, replace: false });
    }

    for (let i in this.tabs) {
      i = parseInt(i, 10);
      let element = this.tabs[i].element;
      if (i === index) {
        element.style.position = 'relative';
        element.style.left = '0';
        this.tabs[i].visible = true;
      } else if (i < index) {
        element.style.position = 'absolute';
        element.style.left = '-100%';
        this.tabs[i].visible = false;
      } else if (i > index) {
        element.style.position = 'absolute';
        element.style.left = '100%';
        this.tabs[i].visible = false;
      }
      if (i === current || i === index) element.style.opacity = '1';else element.style.opacity = '0';
    }
  }

}) || _class) || _class);