'use strict';

System.register(['aurelia-framework', './ka-console/ka-console', './ka-dialog/ka-dialog', './ka-toast/ka-toast', './ka-api/ka-api'], function (_export, _context) {
  "use strict";

  var PLATFORM, KaConsole;
  function configure(config) {
    config.globalResources([PLATFORM.moduleName('./ka-button/ka-button')]);
    config.globalResources([PLATFORM.moduleName('./ka-input/ka-input')]);
    config.globalResources([PLATFORM.moduleName('./ka-input/ka-input-controls')]);
    config.globalResources([PLATFORM.moduleName('./ka-navbar/ka-navbar')]);
    config.globalResources([PLATFORM.moduleName('./ka-resource/ka-resource')]);
    config.globalResources([PLATFORM.moduleName('./ka-table/ka-table')]);
    config.globalResources([PLATFORM.moduleName('./ka-table/ka-tableFilters')]);
    config.globalResources([PLATFORM.moduleName('./ka-tabs/ka-tabs')]);
    config.globalResources([PLATFORM.moduleName('./ka-tooltip/ka-tooltip')]);
    config.globalResources([PLATFORM.moduleName('./ka-enter/ka-enter')]);

    config.globalResources([PLATFORM.moduleName('./ka-progress/ka-progress')]);
    config.globalResources([PLATFORM.moduleName('./ka-layout/ka-layout')]);

    config.globalResources([PLATFORM.moduleName('./ka-control/ka-control')]);
    config.globalResources([PLATFORM.moduleName('./ka-control-check/ka-control-check')]);
    config.globalResources([PLATFORM.moduleName('./ka-control-combo/ka-control-combo')]);
    config.globalResources([PLATFORM.moduleName('./ka-control-date/ka-control-date')]);
    config.globalResources([PLATFORM.moduleName('./ka-control-editor/ka-control-editor')]);
    config.globalResources([PLATFORM.moduleName('./ka-control-file/ka-control-file')]);
    config.globalResources([PLATFORM.moduleName('./ka-control-list/ka-control-list')]);
    config.globalResources([PLATFORM.moduleName('./ka-control-number/ka-control-number')]);
    config.globalResources([PLATFORM.moduleName('./ka-control-password/ka-control-password')]);
    config.globalResources([PLATFORM.moduleName('./ka-control-table/ka-control-table')]);
    config.globalResources([PLATFORM.moduleName('./ka-control-text/ka-control-text')]);
    config.globalResources([PLATFORM.moduleName('./ka-control-textarea/ka-control-textarea')]);
  }

  _export('configure', configure);

  return {
    setters: [function (_aureliaFramework) {
      PLATFORM = _aureliaFramework.PLATFORM;
    }, function (_kaConsoleKaConsole) {
      KaConsole = _kaConsoleKaConsole.KaConsole;
    }, function (_kaDialogKaDialog) {
      var _exportObj = {};

      for (var _key in _kaDialogKaDialog) {
        if (_key !== "default" && _key !== "__esModule") _exportObj[_key] = _kaDialogKaDialog[_key];
      }

      _export(_exportObj);
    }, function (_kaToastKaToast) {
      var _exportObj2 = {};

      for (var _key2 in _kaToastKaToast) {
        if (_key2 !== "default" && _key2 !== "__esModule") _exportObj2[_key2] = _kaToastKaToast[_key2];
      }

      _export(_exportObj2);
    }, function (_kaApiKaApi) {
      var _exportObj3 = {};

      for (var _key3 in _kaApiKaApi) {
        if (_key3 !== "default" && _key3 !== "__esModule") _exportObj3[_key3] = _kaApiKaApi[_key3];
      }

      _export(_exportObj3);
    }],
    execute: function () {

      window.konsole = new KaConsole();
    }
  };
});