'use strict';

System.register(['aurelia-framework', 'aurelia-http-client', 'ka-components'], function (_export, _context) {
  "use strict";

  var inject, customElement, bindable, bindingMode, HttpClient, KaApi, _typeof, _createClass, _dec, _dec2, _dec3, _dec4, _dec5, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, KaControlCombo, kaControlComboHighlightValueConverter;

  function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
      enumerable: descriptor.enumerable,
      configurable: descriptor.configurable,
      writable: descriptor.writable,
      value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
      desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
      desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
      return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
      desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
      desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
      Object['define' + 'Property'](target, property, desc);
      desc = null;
    }

    return desc;
  }

  function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
  }

  return {
    setters: [function (_aureliaFramework) {
      inject = _aureliaFramework.inject;
      customElement = _aureliaFramework.customElement;
      bindable = _aureliaFramework.bindable;
      bindingMode = _aureliaFramework.bindingMode;
    }, function (_aureliaHttpClient) {
      HttpClient = _aureliaHttpClient.HttpClient;
    }, function (_kaComponents) {
      KaApi = _kaComponents.KaApi;
    }],
    execute: function () {
      _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
        return typeof obj;
      } : function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };

      _createClass = function () {
        function defineProperties(target, props) {
          for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) descriptor.writable = true;
            Object.defineProperty(target, descriptor.key, descriptor);
          }
        }

        return function (Constructor, protoProps, staticProps) {
          if (protoProps) defineProperties(Constructor.prototype, protoProps);
          if (staticProps) defineProperties(Constructor, staticProps);
          return Constructor;
        };
      }();

      _export('KaControlCombo', KaControlCombo = (_dec = customElement('ka-control-combo'), _dec2 = inject(Element, KaApi), _dec3 = bindable(), _dec4 = bindable({ defaultBindingMode: bindingMode.twoWay }), _dec5 = bindable(), _dec(_class = _dec2(_class = (_class2 = function () {
        function KaControlCombo(element, api) {
          var _this = this;

          _classCallCheck(this, KaControlCombo);

          _initDefineProp(this, 'schema', _descriptor, this);

          _initDefineProp(this, 'value', _descriptor2, this);

          _initDefineProp(this, 'readonly', _descriptor3, this);

          this._schema = null;
          this._value = null;
          this.opened = false;
          this.combostack = [];
          this.valuestack = [];
          this.preloadedCombostack = [];

          this.element = element;
          this.api = api;

          this.backdrop = document.createElement('ka-control-backdrop');
          this.backdrop.addEventListener('click', function (event) {
            if (event.target === _this.backdrop) _this.close();
          });
        }

        KaControlCombo.prototype.attached = function attached() {};

        KaControlCombo.prototype.schemaChanged = function schemaChanged(schema) {
          if (!schema) {
            konsole.warn('ka-control-combo: missing schema!', schema);
            return;
          }
          if (typeof schema === 'string') {
            try {
              schema = JSON.parse(schema);
            } catch (error) {
              konsole.error('ka-control-combo: invalid schema provided!', schema);
              return;
            }
          }
          if (!schema.datasource) {
            konsole.error('ka-control-combo: missing datasource in schema!', schema);
            return;
          }
          if (typeof schema.datasource === 'string') {
            try {
              schema.datasource = JSON.parse(schema.datasource);
            } catch (error) {
              konsole.error('ka-control-combo: invalid datasource provided in schema!', schema);
              return;
            }
          }
          if (Array.isArray(schema.datasource) && !schema.datapreload) {
            schema.datapreload = true;
          }
          if (!schema.datavalue) {
            schema.datavalue = 'value';
          }
          if (!schema.datatext) {
            schema.datatext = 'text';
          }
          if (!schema.datasearch) {
            schema.datasearch = {};
          } else if (typeof schema.datasearch === 'string') {
            try {
              schema.datasearch = JSON.parse(schema.datasearch);
            } catch (error) {
              konsole.error('ka-control-combo: invalid datasearch provided in schema!', schema);
              return;
            }
          }
          if (!schema.datasearch.operator) {
            schema.datasearch.operator = '^=';
          }
          if (!schema.datasearch.keys) {
            schema.datasearch.keys = schema.datatext;
          }

          var _arr = ['readonly'];

          for (var _i = 0; _i < _arr.length; _i++) {
            var attribute = _arr[_i];
            if (this[attribute] === null) {
              if (this.element.getAttribute(attribute)) {
                this[attribute] = String(this.element.getAttribute(attribute)).toLowerCase() === 'true';
              } else if (_typeof(schema[attribute]) !== undefined) {
                this[attribute] = String(schema[attribute]).toLowerCase() === 'true';
              }
            } else this[attribute] = String(this[attribute]).toLowerCase() === 'true';
          }

          konsole.debug('ka-control-combo: schema changed!', schema);
          this._schema = schema;

          if (this.value && !this._value) this.valueChanged(this.value);

          if (schema.datasource.url) {
            this.api = new HttpClient();
            this.api.configure(function (x) {
              x.withInterceptor({
                response: function response(msg) {
                  if (msg.responseType === 'json' && typeof msg.response === 'string') {
                    msg.response = JSON.parse(msg.response);
                  }
                  return msg;
                }
              });
            });
          }

          if (schema.datamultiple === true) {
            this.element.classList.add('multiple');
          }

          this.buildCombostack();
        };

        KaControlCombo.prototype.valueChanged = function valueChanged(value) {
          if (!this._schema) {
            konsole.warn('ka-control-combo: cannot handle value without schema!');
            return;
          }

          if (!value && !this._value || value === JSON.stringify(this._value)) {
            return;
          }
          if (this._schema.datamultiple === true) {
            if (typeof value === 'string') {
              try {
                value = JSON.parse(value);
              } catch (error) {
                konsole.error('ka-control-combo: invalid value provided!', value);
                return;
              }
            }
            if (!Array.isArray(value)) {
              konsole.warn('ka-control-combo: value should be an array! Trying to convert it...', value);
              value = [String(value)];
            }
          } else {
            if (typeof value !== 'string' && typeof value !== 'number') {
              konsole.error('ka-control-combo: value must be a string or an integer!', value);
              return;
            }
            value = [String(value)];
          }

          konsole.debug('ka-control-combo: value changed!', value);
          this._value = value;

          this.buildValuestack();
        };

        KaControlCombo.prototype.buildCombostack = function buildCombostack() {
          var _this2 = this;

          var dts = this._schema.datasource;
          var dtp = this._schema.datapreload;

          if (dtp === true || Array.isArray(dts)) {
            if (dts.table || dts.url) {
              var endpoint = this.buildQueryUrl();
              this.api.get(endpoint).then(function (x) {
                _this2.combostack = x.response;
                _this2.preloadedCombostack = x.response;
              }).catch(function (x) {
                konsole.error('ka-control-combo: invalid datasource provided in schema!', _this2._schema);
              });
            } else if (Array.isArray(dts)) {
              this.combostack = dts;
              this.preloadedCombostack = dts;
            } else {
              konsole.error('ka-control-combo: invalid datasource provided in schema!', this._schema);
              return;
            }
          }
        };

        KaControlCombo.prototype.buildValuestack = function buildValuestack() {
          var _this3 = this;

          var dtv = this._schema.datavalue;
          var dtt = this._schema.datatext;

          if (!this._value) return;
          var values = this._value;
          var valuestack = [];
          var promises = [];

          var _loop2 = function _loop2() {
            if (_isArray) {
              if (_i2 >= _iterator.length) return 'break';
              _ref = _iterator[_i2++];
            } else {
              _i2 = _iterator.next();
              if (_i2.done) return 'break';
              _ref = _i2.value;
            }

            var value = _ref;

            var matched = _this3.combostack.find(function (x) {
              return String(x.value) === String(value);
            }) || { value: String(value) };
            valuestack.push(matched);
          };

          for (var _iterator = values, _isArray = Array.isArray(_iterator), _i2 = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
            var _ref;

            var _ret2 = _loop2();

            if (_ret2 === 'break') break;
          }
          var unmatched = valuestack.filter(function (x) {
            return !x.text;
          });
          if (unmatched.length) {
            var endpoint = this.buildQueryUrl({ filters: dtv + '~~' + unmatched.map(function (x) {
                return x.value;
              }).join(',') });
            promises.push(this.api.get(endpoint).then(function (x) {
              var response = x.response;

              var _loop = function _loop() {
                if (_isArray2) {
                  if (_i3 >= _iterator2.length) return 'break';
                  _ref2 = _iterator2[_i3++];
                } else {
                  _i3 = _iterator2.next();
                  if (_i3.done) return 'break';
                  _ref2 = _i3.value;
                }

                var item = _ref2;

                var text = '';
                var keys = dtt.match(/\{[a-zA-Z0-9_\.]*?\}/g);
                if (keys) {
                  text = dtt;
                  for (var _iterator3 = keys, _isArray3 = Array.isArray(_iterator3), _i4 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
                    var _ref3;

                    if (_isArray3) {
                      if (_i4 >= _iterator3.length) break;
                      _ref3 = _iterator3[_i4++];
                    } else {
                      _i4 = _iterator3.next();
                      if (_i4.done) break;
                      _ref3 = _i4.value;
                    }

                    var key = _ref3;

                    var replacement = '';
                    key = /\{([^\.]*)\.?(.*)\}/g.exec(key);
                    if (item[key[1]] && key[2] && item[key[1]][key[2]]) replacement = item[key[1]][key[2]];else if (item[key[1]]) replacement = item[key[1]];
                    text = text.replace(key[0], replacement);
                  }
                } else text = item[dtt] || '';
                valuestack.find(function (i) {
                  return i.value === String(item[dtv]);
                }).text = text;
              };

              for (var _iterator2 = response, _isArray2 = Array.isArray(_iterator2), _i3 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
                var _ref2;

                var _ret = _loop();

                if (_ret === 'break') break;
              }
            }));
          }
          Promise.all(promises).finally(function () {
            _this3.valuestack = valuestack;
          });
        };

        KaControlCombo.prototype.open = function open($event) {
          var _this4 = this;

          if (this.readonly || $event.target.tagName === 'I') return;
          if (this.opened) return this.close();
          this._combostack.forEach(function (x) {
            return x.selected = _this4._value && _this4._value.includes(x.value);
          });
          document.body.appendChild(this.backdrop);
          this.opened = true;

          setTimeout(function () {
            var bounds = _this4.drawer.getBoundingClientRect();
            var max_h = _this4.backdrop.getBoundingClientRect().height;
            _this4.backdrop.appendChild(_this4.drawer);
            if (bounds.top + 280 > max_h) {
              _this4.drawer.style.top = 'auto';
              _this4.drawer.style.bottom = max_h - bounds.top - 30 + 60 + 'px';
            } else {
              _this4.drawer.style.top = bounds.top + 'px';
              _this4.drawer.style.bottom = 'auto';
            }
            _this4.drawer.style.left = bounds.left + 'px';
            _this4.drawer.style.width = bounds.width + 'px';

            if (_this4.searchInput) _this4.searchInput.focus();
          }, 0);
        };

        KaControlCombo.prototype.close = function close() {
          this.element.appendChild(this.drawer);
          this.drawer.setAttribute('style', '');
          document.body.removeChild(this.backdrop);
          if (this._schema.datapreload !== true) this.combostack = [];
          this.opened = false;
          this.term = null;
        };

        KaControlCombo.prototype.select = function select(item) {
          var value = this._value || [];
          var multiple = this._schema.datamultiple === true;
          var index = value.indexOf(item.value);
          if (multiple && index > -1) {
            item.selected = false;
            value.splice(index, 1);
            this.valuestack.splice(index, 1);
            if (value.length === 0) value = this._value = null;
          } else if (multiple) {
            item.selected = true;
            value.push(item.value);
            this.valuestack.push(item);
          } else if (!multiple && index > -1) {
            item.selected = false;
            value = this._value = null;
            this.valuestack = [];
            this.close();
          } else if (!multiple) {
            item.selected = true;
            value = item.value;
            this.valuestack = [item];
            this.close();
          }
          this.value = value;
        };

        KaControlCombo.prototype.search = function search() {
          var _this5 = this;

          var dts = this._schema.datasource;
          var dtt = this._schema.datatext;
          var dtp = this._schema.datapreload;
          var dsh = this._schema.datasearch;
          var term = this.term;
          var filters = [];

          if (dtp && this.preloadedCombostack.length > 8) {
            this.combostack = this.preloadedCombostack.filter(function (x) {
              return String(x[dtt]).toUpperCase().indexOf(term.toUpperCase()) === 0;
            });
            return true;
          }

          if (!term || term.length < 2) return true;

          if (!dts.table && !dts.url) {
            return true;
          }

          var keys = dsh.keys.match(/{(.*?)}/g);
          if (keys) {
            var terms = term.trim().split(' ');
            if (terms.length > 1) {
              keys.forEach(function (key, index) {
                if (terms[index]) filters.push('' + key.replace(/{|}/g, '') + dsh.operator + terms[index]);
              });
            } else {
              keys.forEach(function (key, index) {
                filters.push('' + key.replace(/{|}/g, '') + dsh.operator + terms[0]);
              });
              filters = ['(' + filters.join('|') + ')'];
            }
          } else {
            filters.push('' + dtt + dsh.operator + term.trim());
          }

          var endpoint = this.buildQueryUrl({ filters: filters.join('&') });
          if (this.searchRequest && this.searchRequest.cancel) {
            this.searchRequest.cancel();
          }
          this.searchRequest = this.api.get(endpoint);
          this.searchRequest.then(function (x) {
            _this5.combostack = x.response;
            _this5._combostack.forEach(function (c) {
              return c.selected = _this5._value && _this5._value.includes(c.value);
            });
          });
          return true;
        };

        KaControlCombo.prototype.getUrlParams = function getUrlParams(url) {
          var query = url.match(/\?(.*)$/);
          if (!query) return {};
          var chunks = query[1].split('&');
          return chunks.reduce(function (params, hash) {
            var _Object$assign;

            var _hash$split = hash.split('='),
                key = _hash$split[0],
                val = _hash$split[1];

            return Object.assign(params, (_Object$assign = {}, _Object$assign[key] = decodeURIComponent(val), _Object$assign));
          }, {});
        };

        KaControlCombo.prototype.buildQueryUrl = function buildQueryUrl(params) {
          var dts = this._schema.datasource;
          var dtv = this._schema.datavalue;
          var dtt = this._schema.datatext;
          var dtf = this._schema.datafilter;


          if (!dts.table && !dts.url) {
            konsole.error('ka-control-combo: cannot build query url if datasource is not a table or url!', this._schema.datasource);
            return;
          }

          var endpoint = dts.table || dts.url;
          if (dts.table && dts.query) endpoint = endpoint + (endpoint.indexOf('?') > -1 ? '&' : '?') + dts.query;

          var urlParams = this.getUrlParams(endpoint);
          var fields = void 0;
          var sort = void 0;
          var keys = void 0;

          keys = dtt.match(/\{[a-zA-Z0-9_\.]*?\}/g);
          if (keys) {
            keys = keys.map(function (b) {
              return b.replace(/\{(.*?)\}/g, '$1').replace(/([^\.]*).*/g, '$1');
            });
            fields = keys.join(',');
            sort = '+' + keys.join(',+');
          } else {
            fields = dtt;
            sort = '+' + dtt;
          }

          if (dtf) {
            urlParams.filters = (urlParams.filters ? urlParams.filters + '&' : '') + ('(' + dtf + ')');
          }
          if (params && params.filters) {
            urlParams.filters = (urlParams.filters ? urlParams.filters + '&' : '') + ('(' + params.filters + ')');
          }
          urlParams.sort = (urlParams.sort ? urlParams.sort + ',' : '') + sort;
          urlParams.fields = (urlParams.fields ? urlParams.fields + ',' : '') + (dtv + ',' + fields);
          endpoint = endpoint.replace(/\?.*$/, '') + '?' + this.buildQueryString(urlParams);
          return endpoint;
        };

        KaControlCombo.prototype.buildQueryString = function buildQueryString(params) {
          return Object.keys(params).reduce(function (query, key) {
            return query + '&' + key + '=' + encodeURIComponent(params[key]);
          }, '').replace(/^\&/, '');
        };

        _createClass(KaControlCombo, [{
          key: 'combostack',
          get: function get() {
            return this._combostack;
          },
          set: function set(stack) {
            if (!stack || stack.length === 0) {
              this._combostack = [];
              return;
            }
            var dtv = this._schema.datavalue;
            var dtt = this._schema.datatext;
            var combostack = [];
            for (var _iterator4 = stack, _isArray4 = Array.isArray(_iterator4), _i5 = 0, _iterator4 = _isArray4 ? _iterator4 : _iterator4[Symbol.iterator]();;) {
              var _ref4;

              if (_isArray4) {
                if (_i5 >= _iterator4.length) break;
                _ref4 = _iterator4[_i5++];
              } else {
                _i5 = _iterator4.next();
                if (_i5.done) break;
                _ref4 = _i5.value;
              }

              var _item = _ref4;

              var _text = '';
              var _keys = dtt.match(/\{[a-zA-Z0-9_\.]*?\}/g);
              if (_keys) {
                _text = dtt;
                for (var _iterator5 = _keys, _isArray5 = Array.isArray(_iterator5), _i6 = 0, _iterator5 = _isArray5 ? _iterator5 : _iterator5[Symbol.iterator]();;) {
                  var _ref5;

                  if (_isArray5) {
                    if (_i6 >= _iterator5.length) break;
                    _ref5 = _iterator5[_i6++];
                  } else {
                    _i6 = _iterator5.next();
                    if (_i6.done) break;
                    _ref5 = _i6.value;
                  }

                  var key = _ref5;

                  var replacement = '';
                  key = /\{([^\.]*)\.?(.*)\}/g.exec(key);
                  if (_item[key[1]] && key[2] && _item[key[1]][key[2]]) replacement = _item[key[1]][key[2]];else if (_item[key[1]]) replacement = _item[key[1]];
                  _text = _text.replace(key[0], replacement);
                }
              } else _text = _item[dtt] || '';
              combostack.push({ value: String(_item[dtv]), text: _text });
            }
            this._combostack = combostack;
          }
        }, {
          key: 'valuestack',
          get: function get() {
            return this._valuestack;
          },
          set: function set(stack) {
            if (!stack || stack.length === 0) {
              this._valuestack = [];
              return;
            }
            this._valuestack = stack;
          }
        }]);

        return KaControlCombo;
      }(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec3], {
        enumerable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'value', [_dec4], {
        enumerable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'readonly', [_dec5], {
        enumerable: true,
        initializer: function initializer() {
          return null;
        }
      })), _class2)) || _class) || _class));

      _export('KaControlCombo', KaControlCombo);

      _export('kaControlComboHighlightValueConverter', kaControlComboHighlightValueConverter = function () {
        function kaControlComboHighlightValueConverter() {
          _classCallCheck(this, kaControlComboHighlightValueConverter);
        }

        kaControlComboHighlightValueConverter.prototype.toView = function toView(text, term) {
          if (!term) return text;
          var index = text.toLowerCase().indexOf(term.toLowerCase());
          if (index >= 0) text = text.substring(0, index) + '<strong>' + text.substring(index, index + term.length) + '</strong>' + text.substring(index + term.length);
          return text;
        };

        return kaControlComboHighlightValueConverter;
      }());

      _export('kaControlComboHighlightValueConverter', kaControlComboHighlightValueConverter);
    }
  };
});