'use strict';

System.register(['aurelia-framework', 'ka-ckeditor'], function (_export, _context) {
  "use strict";

  var inject, customElement, bindable, bindingMode, ClassicEditor, _typeof, _dec, _dec2, _dec3, _dec4, _dec5, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, KaControlEditor;

  function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
      enumerable: descriptor.enumerable,
      configurable: descriptor.configurable,
      writable: descriptor.writable,
      value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
      desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
      desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
      return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
      desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
      desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
      Object['define' + 'Property'](target, property, desc);
      desc = null;
    }

    return desc;
  }

  function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
  }

  return {
    setters: [function (_aureliaFramework) {
      inject = _aureliaFramework.inject;
      customElement = _aureliaFramework.customElement;
      bindable = _aureliaFramework.bindable;
      bindingMode = _aureliaFramework.bindingMode;
    }, function (_kaCkeditor) {
      ClassicEditor = _kaCkeditor.default;
    }],
    execute: function () {
      _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
        return typeof obj;
      } : function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };

      _export('KaControlEditor', KaControlEditor = (_dec = customElement('ka-control-editor'), _dec2 = inject(Element), _dec3 = bindable(), _dec4 = bindable({ defaultBindingMode: bindingMode.twoWay }), _dec5 = bindable(), _dec(_class = _dec2(_class = (_class2 = function () {
        function KaControlEditor(element) {
          _classCallCheck(this, KaControlEditor);

          _initDefineProp(this, 'schema', _descriptor, this);

          _initDefineProp(this, 'value', _descriptor2, this);

          _initDefineProp(this, 'readonly', _descriptor3, this);

          this.element = element;
        }

        KaControlEditor.prototype.attached = function attached() {};

        KaControlEditor.prototype.schemaChanged = function schemaChanged(schema) {
          if (!schema) {
            konsole.warn('ka-control-editor: missing schema!', schema);
            return;
          }
          if (typeof schema === 'string') {
            try {
              schema = JSON.parse(schema);
            } catch (error) {
              konsole.error('ka-control-editor: invalid schema provided!', schema);
              return;
            }
          }

          var _arr = ['readonly'];

          for (var _i = 0; _i < _arr.length; _i++) {
            var attribute = _arr[_i];
            if (this[attribute] === null) {
              if (this.element.getAttribute(attribute)) {
                this[attribute] = String(this.element.getAttribute(attribute)).toLowerCase() === 'true';
              } else if (_typeof(schema[attribute]) !== undefined) {
                this[attribute] = String(schema[attribute]).toLowerCase() === 'true';
              }
            } else this[attribute] = String(this[attribute]).toLowerCase() === 'true';
          }

          konsole.debug('ka-control-editor: schema changed!', schema);
          this._schema = schema;

          this.buildEditor();
        };

        KaControlEditor.prototype.valueChanged = function valueChanged(value) {
          var _this = this;

          if (!this.editor || this.editorValuePending || this.editor.getData() === value) return;
          konsole.debug('ka-control-editor: value changed!', value);
          this.editorValuePending = true;
          this.editor.setData(value || '');
          setTimeout(function () {
            _this.editorValuePending = false;
          }, 0);
        };

        KaControlEditor.prototype.readonlyChanged = function readonlyChanged(readonly) {
          if (this.editor) this.editor.isReadOnly = readonly;
        };

        KaControlEditor.prototype.buildEditor = function buildEditor() {
          var _this2 = this;

          if (this._editor_initialized) return;
          var config = {
            toolbar: {
              items: ['heading', '|', 'bold', 'italic', 'strikethrough', 'superscript', 'subscript', 'removeFormat', '|', 'bulletedList', 'numberedList', '|', 'alignment', 'indent', 'outdent', '|', 'link', 'imageUpload', 'blockQuote', 'insertTable', 'mediaEmbed', 'undo', 'redo', '|', 'code']
            },
            language: 'it',
            image: {
              toolbar: ['imageTextAlternative', 'imageStyle:full', 'imageStyle:side']
            },
            table: {
              contentToolbar: ['tableColumn', 'tableRow', 'mergeTableCells']
            }
          };
          ClassicEditor.create(this.element, config).then(function (editor) {
            editor.setData(_this2.value || '');
            editor.isReadOnly = _this2.readonly;
            editor.model.document.on('change:data', function () {
              _this2.value = editor.getData();
            });
            _this2.editor = editor;
          }).catch(function (error) {
            konsole.error('There was a problem initializing ckeditor', error);
          }).finally(function () {
            _this2._editor_initialized = true;
          });
        };

        return KaControlEditor;
      }(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec3], {
        enumerable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'value', [_dec4], {
        enumerable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'readonly', [_dec5], {
        enumerable: true,
        initializer: function initializer() {
          return null;
        }
      })), _class2)) || _class) || _class));

      _export('KaControlEditor', KaControlEditor);
    }
  };
});