'use strict';

System.register(['aurelia-framework'], function (_export, _context) {
  "use strict";

  var inject, customElement, bindable, bindingMode, _typeof, _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, KaControlFile;

  function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
      enumerable: descriptor.enumerable,
      configurable: descriptor.configurable,
      writable: descriptor.writable,
      value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
      desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
      desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
      return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
      desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
      desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
      Object['define' + 'Property'](target, property, desc);
      desc = null;
    }

    return desc;
  }

  function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
  }

  return {
    setters: [function (_aureliaFramework) {
      inject = _aureliaFramework.inject;
      customElement = _aureliaFramework.customElement;
      bindable = _aureliaFramework.bindable;
      bindingMode = _aureliaFramework.bindingMode;
    }],
    execute: function () {
      _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
        return typeof obj;
      } : function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };

      _export('KaControlFile', KaControlFile = (_dec = customElement('ka-control-file'), _dec2 = inject(Element), _dec3 = bindable(), _dec4 = bindable({ defaultBindingMode: bindingMode.twoWay }), _dec5 = bindable(), _dec6 = bindable(), _dec7 = bindable(), _dec(_class = _dec2(_class = (_class2 = function () {
        function KaControlFile(element) {
          _classCallCheck(this, KaControlFile);

          _initDefineProp(this, 'schema', _descriptor, this);

          _initDefineProp(this, 'value', _descriptor2, this);

          _initDefineProp(this, 'readonly', _descriptor3, this);

          _initDefineProp(this, 'placeholder', _descriptor4, this);

          _initDefineProp(this, 'params', _descriptor5, this);

          this.element = element;
        }

        KaControlFile.prototype.attached = function attached() {};

        KaControlFile.prototype.schemaChanged = function schemaChanged(schema) {
          if (!schema) {
            konsole.warn('ka-control-file: missing schema!', schema);
            return;
          }
          if (typeof schema === 'string') {
            try {
              schema = JSON.parse(schema);
            } catch (error) {
              konsole.error('ka-control-file: invalid schema provided!', schema);
              return;
            }
          }

          var _arr = ['readonly'];

          for (var _i = 0; _i < _arr.length; _i++) {
            var attribute = _arr[_i];
            if (this[attribute] === null) {
              if (this.element.getAttribute(attribute)) {
                this[attribute] = String(this.element.getAttribute(attribute)).toLowerCase() === 'true';
              } else if (_typeof(schema[attribute]) !== undefined) {
                this[attribute] = String(schema[attribute]).toLowerCase() === 'true';
              }
            } else this[attribute] = String(this[attribute]).toLowerCase() === 'true';
          }

          konsole.debug('ka-control-file: schema changed!', schema);
          this._schema = schema;
        };

        KaControlFile.prototype.valueChanged = function valueChanged(value) {
          konsole.debug('ka-control-file: value changed!', value);
          if (typeof value === 'undefined' || value === '' || value && !value.length) value = null;
          this.displayValue = value && value.length && value[0] && value[0].name ? value[0].name : value;
        };

        KaControlFile.prototype.clear = function clear() {
          this.value = null;
        };

        KaControlFile.prototype.download = function download() {
          if (!this.value || !this.params.download) return;
          window.open(this.params.download);
        };

        return KaControlFile;
      }(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec3], {
        enumerable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'value', [_dec4], {
        enumerable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'readonly', [_dec5], {
        enumerable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'placeholder', [_dec6], {
        enumerable: true,
        initializer: function initializer() {
          return '';
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'params', [_dec7], {
        enumerable: true,
        initializer: function initializer() {
          return null;
        }
      })), _class2)) || _class) || _class));

      _export('KaControlFile', KaControlFile);
    }
  };
});