import {inject, customAttribute} from 'aurelia-framework';

@customAttribute('ka-enter')
@inject(Element)
export class KaEnterCustomAttribute {
  _callback = null;

  constructor(element) {
    this.element = element;

    this.element.addEventListener('keydown', (e) => {
      let inputs = [];
      if (this.element.tagName === 'INPUT') inputs = [this.element];
      else inputs = Array.from(this.element.querySelectorAll('input'));
      if (e.keyCode === 13 && inputs.includes(e.target)) {
        if (typeof this._callback === 'function') {
          e.target.blur();
          this._callback({ event: e });

        }
      }
    });
  }

  bind() {
    this._callback = this.value;
  }
}

