import {inject, customElement, bindable, bindingMode} from 'aurelia-framework';

@customElement('ka-input')
@inject(Element)
export class KaInput {

  @bindable({defaultBindingMode: bindingMode.twoWay}) value = null;
  // Kamaji's field configuration
  @bindable() config = null;
  // Reference to record id
  @bindable() record = null;
  // Field configuration overrides
  @bindable() name = null;
  @bindable() label = null;
  @bindable() default = null;
  @bindable() required = null;
  @bindable() readonly = null;
  @bindable() control = null;
  @bindable() client = null;
  @bindable() description = null;
  @bindable() change = null;
  @bindable() ready = null;
  @bindable() dialogClosed = null;
  @bindable() validation = true;
  @bindable() queryOperator = null;

  @bindable({defaultBindingMode: bindingMode.twoWay}) resourceControls = null; // needed for md-input-array
  @bindable() resourceRef = null; // needed for md-input-array

  insideMdResource = null;

  constructor(element) {
    this.element = element;
  }

  bind(bindingContext) {
    this.parent = bindingContext;
    if (bindingContext) {
      this.insideMdResource = !!(this.name && bindingContext.constructor.name === 'MdResource' && bindingContext.controls);
    }
  }

  attached() {
    if (this.resourceControls &&  this.resourceRef && this.input) {
      this.resourceControls[this.resourceRef] = this.input;  // needed for md-input-array
    }
    /*
    let input = this.element.getElementsByTagName('ka-input-controls')[0];
    if (!input) return; // setTimeout(()=>{ console.log('ka-input attached() handler retrying to find child ka-input-controls'); this.attached(); }, 100);
    while (input.childNodes.length) this.element.appendChild(input.firstChild);
    */
  }

  resourceControlsChanged(resourceControls) {
    if (this.resourceControls && this.input) {
      this.resourceControls = this.input;  // needed for md-input-array
    }
  }
}
