export class KaToast {
  duration = 4000;
  transition = 500;
  hold = false;
  stack = [];

  constructor() {
  }

  show(message, elementClass, hold = false) {
    message = message || '';
    elementClass = elementClass || '';
    this.stack.push({ message, elementClass, hold });
    this.consume();
  }

  consume() {
    if (this.holdedElement) {
      this.holdedElement.remove();
      this.hold = false;
      this.holdedElement = null;
    }
    if (this.stack.length && !this.hold) {
      this.hold = true;
      let current = this.stack.shift();
      let element = document.createElement('div');
      element.classList.add('ka-toast');
      element.classList.add(`ka-toast-${current.elementClass}`);
      element.innerHTML = current.message;
      document.body.append(element);

      setTimeout(() => {
        element.classList.add('visible');
      }, this.transition);

      if (!current.hold) {
        this.holdedElement = null;
        setTimeout(() => {
          element.classList.remove('visible');
          setTimeout(() => {
            element.remove();
            this.hold = false;
            this.consume();
          }, this.transition);
        }, this.duration - this.transition);
      } else {
        this.holdedElement = element;
      }
    }
  }
}
